//=============================================================================
// IPconfig.c    ணࠬ 뢮 䨣樨 TCP/IP
//=============================================================================
#define INCL_DOSPROCESS

#include <os2.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <types.h>
#include <sys\socket.h>
#include <sys\ioctl.h>
#include <netinet\in.h>
#include <netinet\ip_var.h>
#include <sys\sysctl.h>
#include "route.h"
#include <net\if.h>
#include <arpa\inet.h>
#include <unistd.h>

void main(int argc, char *argv[])
{
FILE *InFile;
char buf[1024], RESOLV2[CCHMAXPATH], Line[128], var[2][128], *ptr;
int i, j, k, sock, intf;
unsigned long myMask;
short NumbInt;
struct statatreq *pStat;
struct in_addr in = { 0 };
struct ifmib ifm = { 0 };
struct rtentries rout = { 0 };
struct ortentry *por;
BOOL domain = TRUE; //   ᪠
BOOL Lang = TRUE;       //  㦥 㦥 (᪨)
BOOL SetLang = FALSE;   //    
PPIB pib;
HAB hab;

char PgmMsg[][80] = {
  "\nUsage: %s [lang]\n\n",                                   // 0
  "Where: lang = en - English language\n",                    // 1
  "              ru - Russian language\n",                    // 2

  "Interface index...: %d\n",                                 // 3
  "Interface name....: lan%d\n",                              // 4
  "Interface name....: loopback\n",                           // 5
  "Interface name....: ppp%d\n",                              // 6
  "Type..............: %s\n",                                 // 7
  "MAC address.......: %2.2x%2.2x-%2.2x%2.2x-%2.2x%2.2x\n",   // 8
  "IP address........: %s\n",                                 // 9
  "Mask..............: %s\n",                                 // 10
  "Broadcast address.: %s\n",                                 // 11
  "MTU size..........: %d\n\n",                               // 12

  "Routing table information\n",                                           // 13
  "Destination      Router           Mask            Metric  Interface\n", // 14
  "default          ",                                                     // 15

  "Host name.........: %s\n",                       // 16
  "Statement SET ETC not found in CONFIG.SYS\n\n",  // 17
  "File %s not found\n\n",                          // 18
  "Domain name.......: %s\n",                       // 19
  "DNS server........: %s\n"                        // 20
  };

// ।  ணࠬ
  if ( argc > 1 )
    {
    memset(buf, 0, 3);
    memcpy(buf, argv[1], 2);
    if ( (argc > 1) && (strcmpi(argv[1], "EN") ==  0) )
      SetLang = TRUE;
    if ( (argc > 1) && (strcmpi(argv[1], "RU") ==  0) )
      { Lang = FALSE; SetLang = TRUE; }
    }

  if ( !SetLang ) //    
    if ( (ptr=getenv("LANG")) != NULL )
      {
      memset(buf, 0, 3);
      memcpy(buf, ptr, 2);
      if ( strcmpi(buf, "RU") ==  0 ) Lang = FALSE;
      }

// 㧨 騥 ᮮ饭
   if ( !Lang )
     {
     DosGetInfoBlocks(NULL, &pib);
     pib->pib_ultype = 3; //  ਫ - PM
     hab = WinInitialize(0);

     for (i=0; i<(sizeof(PgmMsg)/sizeof(PgmMsg[0])); i++)
       WinLoadString(hab, NULLHANDLE, i, sizeof(PgmMsg[0]), PgmMsg[i]);

     WinTerminate (hab);
     }

// 뢥 help
  if ( (argc > 1) && (strchr(argv[1], '?')  != NULL) )
    {
    printf(PgmMsg[0], argv[0]);
    printf(PgmMsg[1]);
    printf(PgmMsg[2]);
    return;
    }

  printf("\n%s 1.0\n\n", argv[0]);

// Get all interface information
  sock = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
  if ( (i=os2_ioctl(sock, SIOSTATAT, buf, sizeof(buf))) != 0 )
    { psock_errno("os2_ioctl(SIOSTATAT)"); soclose(sock); return; }
  if ( (i=os2_ioctl(sock, SIOSTATIF42, (char *)&ifm, sizeof(ifm))) != 0 )
    { psock_errno("os2_ioctl(SIOSTATIF42)"); soclose(sock); return; }
  if ( (i=os2_ioctl(sock, SIOSTATRT, (char *)&rout, sizeof(rout))) != 0 )
    { psock_errno("os2_ioctl(SIOSTATRT)"); soclose(sock); return; }
  soclose(sock);

// 砥 ଠ  䥩
  NumbInt=*(short *)&buf;
  for (i=0, pStat=(struct statatreq *)&buf[2]; i<NumbInt; i++, pStat++)
    {
    intf =  pStat->interface;
    printf(PgmMsg[3], intf);
    if ( intf <  9 ) printf(PgmMsg[4], intf);
    if ( intf == 9 ) printf(PgmMsg[5]);
    if ( intf >  9 ) printf(PgmMsg[6], intf-10);
    printf(PgmMsg[7], ifm.iftable[intf].iftDescr);
    printf(PgmMsg[8],
           ifm.iftable[intf].iftPhysAddr[0], ifm.iftable[intf].iftPhysAddr[1],
           ifm.iftable[intf].iftPhysAddr[2], ifm.iftable[intf].iftPhysAddr[3],
           ifm.iftable[intf].iftPhysAddr[4], ifm.iftable[intf].iftPhysAddr[5]);
    printf(PgmMsg[9], inet_ntoa(*(struct in_addr *)pStat));
    in.s_addr=htonl(pStat->mask);
    printf(PgmMsg[10], inet_ntoa(in));
    in.s_addr=pStat->broadcast;
    printf(PgmMsg[11], inet_ntoa(in));
    printf(PgmMsg[12], ifm.iftable[intf].iftMtu);
    }

// ᯥ⠥ ⠡ ⮢
  printf(PgmMsg[13]);
  printf(PgmMsg[14]);
  for (i=0, ptr=(char *)&rout.rttable[0]; i<(rout.hostcount+rout.netcount); i++)
    {
    por=(struct ortentry *)ptr;
    if ( por->destination.s_addr == 0 ) printf(PgmMsg[15]);
    else
      {
      sprintf(buf, "%s", inet_ntoa(por->destination));
      for (myMask=0xff000000, k=0; k<3; k++, myMask>>=8 )
        if ( (por->mask.s_addr & myMask) != 0 ) break;
        else
          for ( j=strlen(buf)-1; j>0; j-- )
            {
            if ( buf[j] != '.' ) buf[j] = 0;
            else { buf[j] = 0; break; }
            }
      printf("%-17.17s", buf);
      }
    printf("%-17.17s", inet_ntoa(por->gateway));
    printf("%-18.18s", inet_ntoa(por->mask));
    printf("%-6d", por->metric);
    printf("%s\n", ptr+sizeof(struct ortentry));
    ptr=ptr+sizeof(struct ortentry)+strlen(ptr+sizeof(struct ortentry))+1;
    }
  printf("\n");

// ⠥  
  if ( gethostname(buf, sizeof(buf)) == 0 ) printf(PgmMsg[16], buf);

// ६  ६ ETC
  if ( (ptr=getenv("ETC")) == NULL)
    { printf(PgmMsg[17]); return; }

// ⠥ ଠ  䠩 RESOLV2
  strcpy(RESOLV2, ptr);
  strcat(RESOLV2,"\\RESOLV2");
  if ( (InFile=fopen(RESOLV2, "r")) == NULL)
    { printf(PgmMsg[18], RESOLV2); return; }

  for (i=0; i<3;)
    {
    memset(var, 0, sizeof(var));
    if ( fgets(Line, sizeof(Line), InFile) == NULL ) break;
    sscanf(Line, "%s %s", var[0], var[1]);
    if ( domain && (strcmpi(var[0], "DOMAIN") == 0) )
      {
      printf(PgmMsg[19], var[1]);
      domain = FALSE;
      continue;
      }
    if ( strcmpi(var[0], "NAMESERVER") == 0 )
      {
      if ( i == 0 ) printf(PgmMsg[20], var[1]);
      else printf("                  : %s\n", var[1]);
      domain = FALSE; i++;
      }
    }
  fclose(InFile);
}