//=============================================================================
// LANwizrd.c (LAN Wizard)
// ணࠬ   짮⥫ SVISTA  䨣஢ 
//=============================================================================
#define INCL_WIN
#define INCL_DOSPROCESS
#define INCL_GPIBITMAPS

#define HelpCY    20 // cy size for Help text
#define ICOcx     40 // cx size for icon
#define ICOcy     40 // cy size for icon
#define DB_UP   0x0400 // ਯ 
#define DB_DOWN 0x0800 //  

#include <os2.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <types.h>
#include <netinet\in.h>
#include <arpa\inet.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <direct.h>
#include "LANwizrd.h"

//-----------------------------------------------------------------------------
// Prototypes
//-----------------------------------------------------------------------------
MRESULT EXPENTRY ClientWndProc(HWND, ULONG, MPARAM, MPARAM);
MRESULT EXPENTRY ODlgMain(HWND, ULONG, MPARAM, MPARAM);
MRESULT EXPENTRY HDlgMain(HWND, ULONG, MPARAM, MPARAM);
MRESULT EXPENTRY DlgNodeR(HWND, ULONG, MPARAM, MPARAM);
MRESULT EXPENTRY DlgNodePC(HWND, ULONG, MPARAM, MPARAM);
MRESULT EXPENTRY DlgNodeVM(HWND, ULONG, MPARAM, MPARAM);
MRESULT EXPENTRY DlgLAN(HWND, ULONG, MPARAM, MPARAM);
MRESULT EXPENTRY DlgNodePC1(HWND, ULONG, MPARAM, MPARAM);
MRESULT EXPENTRY DlgNodeVM1(HWND, ULONG, MPARAM, MPARAM);
MRESULT EXPENTRY DlgLAN1(HWND, ULONG, MPARAM, MPARAM);

void ViewCfg(char *);
void FormNew(void);
void FormTmpParm(void);
BOOL TestCfgIP(void);
BOOL TestCfgIP1(void);
void SaveCfg(void);
BOOL LoadCfg(void);
void ViewCfg(char *);
void FormCfg(void);
void FormCfg1(void);

#define GetParm(ParmID,ParmName) { \
if ( PrfQueryProfileSize(hini, AppName, ParmID, &ulSize) ) \
  if ( ulSize == sizeof(ParmName) ) \
    PrfQueryProfileData(hini, AppName, ParmID, &ParmName, &ulSize); \
  else return(FALSE); \
else return(FALSE); }

//-----------------------------------------------------------------------------
// Global Variablies
//-----------------------------------------------------------------------------
HAB hab;   // Anchor
HWND hwndFrame, hwndHelpTxt;
HINI hini; // Handle to private INI file
HPOINTER hptr;
char AppName[] = "LANwizard";
char WinPos[] = "WindowPosSize";
char ClassName[] = "LANwizard";
char IniName[] = "LANWIZRD.INI";
int minCX = 465;   // cx size for window
int minCY = 510;   // cy size for window
int MenuZakl = 70; // cy   + 
int BlankSpc = 5;  //   titlebar
int Odialog = ODIALOG_ID;
int Hdialog = HDIALOG_ID;
ULONG ulSize; // Size of the data to be copied
BOOL FlagHlp = FALSE;
short PCid, LANid;
long ColorBlack = CLR_BLACK, ColorRed = CLR_RED;
char ErrTitle[] = "LAN Wizard error";
char browserExe[CCHMAXPATH] = "", browserDir[CCHMAXPATH] = "",
     lngPath[CCHMAXPATH], PathExe[CCHMAXPATH], addr[64], LANG[3] = "En";
char *StartAdr[] = {"192.168.1.0", "192.168.11.0", "192.168.12.0"};
char *Msk[] = {"255.0.0.0", "255.255.0.0", "255.255.255.0"};
char *OStxt[] = { "eComStation (OS/2)", "Linux", "Windows" };
char *NodeIPaddr[] = { "192.168.1.1", "192.168.1.2", "192.168.11.1",
                       "192.168.1.3", "192.168.12.1", "192.168.11.2",
                       "192.168.11.3", "192.168.12.2" };
// ࠬ  
u_long OIPaddrVM[3];  // IP- VM1, VM2, VM3
u_long tOIPaddrVM[3];  // IP- VM1, VM2, VM3
u_long OIPaddrPC1[2]; // IP- PC1
u_long OIPaddrPC2[2]; // IP- PC2
u_long tOIPaddrPC1[2]; // IP- PC1
u_long tOIPaddrPC2[2]; // IP- PC2
u_long OLANaddr[3]; // Real LAN, Virt LAN1, Virt LAN2
int OOS[3];
u_long OMask[3];  // Mask for Real LAN, Virt LAN1, Virt LAN2
USHORT OClass[3]; // Network class for Real, Virt1, Virt2
u_long OIPaddrR;      // IP- Router
u_long OIPaddrPC1[2]; // IP- PC1
u_long OIPaddrPC2[2]; // IP- PC2
u_long OIPaddrVM[3];  // IP- VM1, VM2, VM3
u_long tOLANaddr[3]; // Real LAN, Virt LAN1, Virt LAN2
u_long tOMask[3];  // Mask for Real LAN, Virt LAN1, Virt LAN2
USHORT tOClass[3]; // Network class for Real, Virt1, Virt2
u_long tOIPaddrR;      // IP- Router
u_long tOIPaddrPC1[2]; // IP- PC1
u_long tOIPaddrPC2[2]; // IP- PC2
u_long tOIPaddrVM[3];  // IP- VM1, VM2, VM3
// ࠬ  
u_long HLANaddr[2]; // Real LAN, Virt LAN1
int HOS[2], Nat = 1;
u_long HMask[2];  // Mask for Real LAN, Virt LAN1
USHORT HClass[2]; // Network class for Real, Virt1
u_long HIPaddrPC1[2]; // IP- PC1
u_long HIPaddrVM[2];  // IP- VM1, VM2
u_long tHLANaddr[2]; // Real LAN, Virt LAN1
u_long tHMask[2];  // Mask for Real LAN, Virt LAN1
USHORT tHClass[2]; // Network class for Real, Virt1
u_long tHIPaddrPC1[2]; // IP- PC1
u_long tHIPaddrVM[2];  // IP- VM1, VM2

char PgmMsg[][80] = {
  "Incorrect IP-address",                                             //  0
  "Incorrect network number",                                         //  1
  "Duplicate network number",                                         //  2
  "Host number is zero",                                              //  3
  "Host number is broadcast address",                                 //  4
  "Duplicate IP-address",                                             //  5
  "Host belongs to other network",                                    //  6
  "Virtual network",                                                  //  7
  "Real network",                                                     //  8
  "",                                                                 //  9
  "Help",                                                             // 10
  "",                                                                 // 11
  "",                                                                 // 12
  "",                                                                 // 13
  "Network class",                                                    // 14
  "Network number",                                                   // 15
  "Enter IP-address",                                                 // 16
  "Real interface lan0",                                              // 17
  "Virtual interface lan1" ,                                          // 18
  "",                                                                 // 19
  "INI-file does not exist or it is corrupted, use default configuration",  // 20
  "",                                                                 // 21
  "Home",                                                             // 22
  "Office",                                                           // 23
  "Class",                                                            // 24
  "New configuration",                                                // 25
  "Open configuration",                                               // 26
  "Save configuration",                                               // 27
  "View report",                                                      // 28
  "",                                                                 // 29
  "HOST PC",                                                          // 30
  "Virtual Machine VM"                                                // 31
  };

char CfgMsg[][128] = {
  "iso-8859-1",                                                                                    //  0
  "Network configuration",                                                                         //  1
  "Each node configuration is a part of the network configuration.",                               //  2
  "That is why you should consider nodes parameters' as the integral whole.",                      //  3
  "If you are planning to examine these parameters later, save this file (File -> save page as).", //  4
  "You can open the saved file later with your browser.",                                          //  5
  " mask is %s",                                                                                   //  6
  "Gateway to network %s is",                                                                      //  7
  "",                                                                                              //  8
  "For instance, use TCPCFG2.CMD procedure with eComStation (OS/2).",                              //  9
  "Find below the example of setup.cmd procedure.",                                                // 10
  "REM Remove all entries in the %s",                                                              // 11
  "routing table",                                                                                 // 12
  "ARP cache",                                                                                     // 13
  "REM Assign the address to the loopback interface",                                              // 14
  "REM Assign the address to the lan%d interface",                                                 // 15
  "REM Route to network %s is via %s%d",                                                           // 16
  "REM Enable IP forwarding",                                                                      // 17
  "Do not forget to point out to the address of the DNS server.",                                  // 18
  "For instance, for eComstation (OS/2) write line looks like",                                    // 19
  "into x:\\MPTN\\ETC\\resolv2 file. Here 153.11.7.31 is the DNS address.",                        // 20
  "Real interface lan0 is %s,",                                                                    // 21
  "Virtual interface lan%d is %s,",                                                                // 22
  "Default gateway is %s (%s)",                                                                    // 23
  "Enter these parameters using %s tool.",                                                         // 24
  "For instance, use TCPCFG2.CMD procedure.",                                                      // 25
  "Operation system is",                                                                           // 26
  "For instance, use netconf command.",                                                            // 27
  "My network neighbourhood -> Properties ->",                                                     // 28
  "LAN connection -> Properties ->",                                                               // 29
  "Internet protocol (TCP/IP) -> Properties",                                                      // 30
  "your Operation System",                                                                         // 31
  "Configure your browser (Mozilla):",                                                             // 32
  "Edit->Preferances->Proxies->Direct connection to the Internet",                                 // 33
  "Edit->Preferances->Proxies->HTTP Proxy: %s Port: 3128",                                         // 34
  "Edit->Preferances->Proxies->SOCKS Host: %s Port: 1080<br>SOCKS v4",                             // 35
  "Configure your browser (Internet Explorer):",                                                   // 36
  "Service->Properties->Connections->LAN settings->Do NOT use proxy-server",                       // 37
  "Service->Properties->Connections->LAN settings->Use proxy-server",                              // 38
  "Address: %s Port: %d",                                                                          // 39
  "Use",                                                                                           // 40
  "Screenshots of NAT configuration for InJoy Dialer",                                             // 41
  "HOST PC",                                                                                       // 42
  "Virtual Machine VM",                                                                            // 43
  "Default gateway is %s (%s%d)",                                                                  // 44
  "REM Add default gateway %s%d",                                                                  // 45
  "REM Add default gateway %s",                                                                    // 46
  "; Global parameters",                                                                           // 47
  "; Path and name of log-file",                                                                   // 48
  "; Path and name of log-file for daemon's clients",                                              // 49
  "; A maximal number of simultaneous clients",                                                    // 50
  "; Serivces definition for socks server",                                                        // 51
  "; Socksd is on all interfaces, port 1080",                                                      // 52
  "; User description section",                                                                    // 53
  "; Allow access from local IP addresses to any destination",                                     // 54
  "; Default rule - allow the access",                                                             // 55
  "# The port number where Squid will listen for HTTP client",                                     // 56
  "# Cache definition",                                                                            // 57
  "# Cache logging file",                                                                          // 58
  "# Any IP-address",                                                                              // 59
  "# Our IP-addresses",                                                                            // 60
  "# Allowing access from my_networks",                                                            // 61
  "# Denying access from anywhere",                                                                // 62
  "# Allow replies to client requests",                                                            // 63
  "# Disable ICP",                                                                                 // 64
  "# Your PC Hostname",                                                                            // 65
  "In order to start Squid use command Squid2_32 -D or Squid2 -D.",                                // 66
  "; Serivces definition for TCP mapper",                                                          // 67
  "; Map TCP port 53 (DNS port) to Internet Service Provider DNS IP-address",                      // 68
  "; Serivces definition for UDP mapper",                                                          // 69
  "; Map UDP port 53 (DNS port) to Internet Service Provider DNS IP-address",                      // 70
  "Enter your Internet Service Provider DNS server IP-address here",                                                // 71
  "into x:\\MPTN\\ETC\\resolv2 file. Here %s is the DNS server IP-address (it is the lan1 IP-address of your PC).", // 72
  "With SOCKSD the DNS server IP-address is the lan1 IP-address of your PC."                                        // 73
  };

//=============================================================================
// Main procedure
//=============================================================================
void main(int argc, char *argv[])
{
FILE *InFile;
HMQ hmq;   // Message queue handle
QMSG qmsg; // Message struct
ULONG flFrameFlags = FCF_TITLEBAR   | FCF_SYSMENU | FCF_SHELLPOSITION |
                     FCF_SIZEBORDER | FCF_MINBUTTON | FCF_TASKLIST |
                     FCF_AUTOICON   | FCF_ICON;
char PgmTitle[] = "LAN Wizard 2.0.4", *prfApp = "WPURLDEFAULTSETTINGS";
char *ptr, line[144], Numb[3];
int i, NumbMsg, Number;

// Initialize application and create message queue
  hab = WinInitialize(0);
  hmq = WinCreateMsgQueue(hab, 0);
// । , 㤠 맢 ணࠬ
  strcpy(PathExe, argv[0]);
  for (i=0; i<strlen(PathExe); i++)
    if ( PathExe[i] == '\\' ) PathExe[i] = '/';
  for (i=strlen(PathExe); i>0; i--)
    if ( PathExe[i] == '/' )
      {
      PathExe[i+1] = '\0';
      break;
      }
// ६  몮
  memset(LANG, 0, sizeof(LANG));
  if ( (argc > 1) && (strlen(argv[1]) >= 2 ) ) memcpy(LANG, argv[1], 2); //   
  else
    if ( ((ptr=getenv("LANG")) != NULL) && (strlen(ptr) >= 2) ) memcpy(LANG, ptr, 2);
// ⠥ ࠧਢ  ⮬ 몥
  strcpy(lngPath, PathExe);
  strcat(lngPath, "PgmMsg");
  strcat(lngPath, LANG);
  strcat(lngPath, ".lng");

  memset(Numb, 0, sizeof(Numb));
  NumbMsg = sizeof(PgmMsg)/80;
  if ( (InFile=fopen(lngPath, "r")) != NULL )
    {
    for ( ; fgets(line, sizeof(line), InFile) != NULL; )
      {
      if ( strlen(line) < 4) continue;
      memcpy(Numb, line, 2);
      Number=atoi(Numb);
      if ( (Number < 1) || (Number > NumbMsg) ) continue;
      if ( strlen(line) > 82 ) line[83] = '\0';
      line[strlen(line)-1] = '\0'; // 㡥६ " ப"
      strcpy(PgmMsg[Number-1], line+3);
      }
    fclose(InFile);
    }
// ⠥ 뢮 䨣  ⮬  몥
  strcpy(lngPath, PathExe);
  strcat(lngPath, "CfgMsg");
  strcat(lngPath, LANG);
  strcat(lngPath, ".lng");

  memset(Numb, 0, sizeof(Numb));
  NumbMsg = sizeof(CfgMsg)/128;
  if ( (InFile=fopen(lngPath, "r")) != NULL )
    {
    for ( ; fgets(line, sizeof(line), InFile) != NULL; )
      {
      if ( strlen(line) < 4) continue;
      memcpy(Numb, line, 2);
      Number=atoi(Numb);
      if ( (Number < 1) || (Number > NumbMsg) ) continue;
      if ( strlen(line) > 130 ) line[131] = '\0';
      line[strlen(line)-1] = '\0'; // 㡥६ " ப"
      strcpy(CfgMsg[Number-1], line+3);
      }
    fclose(InFile);
    }
// ६  㧥஬
  PrfQueryProfileString(HINI_USER, prfApp, "DefaultBrowserExe", "",
                        browserExe, CCHMAXPATH);
  PrfQueryProfileString(HINI_USER, prfApp, "DefaultWorkingDir", "",
                        browserDir, CCHMAXPATH);
// Register class and create window
  WinRegisterClass(hab, ClassName, ClientWndProc, CS_SIZEREDRAW, 0);
  hwndFrame = WinCreateStdWindow(HWND_DESKTOP, WS_VISIBLE, &flFrameFlags,
                ClassName, PgmTitle, 0, NULLHANDLE, MAIN_ID, NULLHANDLE);
// Message loop
  while (WinGetMsg (hab, &qmsg, 0, 0, 0)) WinDispatchMsg(hab, &qmsg);
// Clean up (destroy window, queue and hab)
  WinDestroyWindow (hwndFrame);
  WinDestroyMsgQueue (hmq);
  WinTerminate (hab);
}

//=============================================================================
// Window procedure
//=============================================================================
MRESULT EXPENTRY ClientWndProc (HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
static HPS hps;
static RECTL rcl = {-5,-5, 27, 27};
static hwndNoteBook, hwndPage1, hwndPage2,
       hwndNew, hwndOpen, hwndSave, hwndView, hwndHelp;
static ULONG PageOfficeID, PageHomeID;
int i;

  switch (msg)
    {
//-----------------------------------------------------------------------------
// ࠡ⠥ ⨥ 設  1
//-----------------------------------------------------------------------------
    case WM_BUTTON1DOWN:
      {
      if ( (FlagHlp == New)  || (FlagHlp == Open) || (FlagHlp == Save) ||
           (FlagHlp == View) || (FlagHlp == Hlp) )
        {
        hps = WinGetPS(WinWindowFromID(hwnd, FlagHlp));
        WinDrawBorder(hps, &rcl, 1, 1, 0, 0, DB_DOWN);
        WinReleasePS(hps);
        }
      break;
      }
//-----------------------------------------------------------------------------
// ࠡ⠥ ⦠⨥ 設  1
//-----------------------------------------------------------------------------
    case WM_BUTTON1UP:
      {
      if ( (FlagHlp == New)  || (FlagHlp == Open) || (FlagHlp == Save) ||
           (FlagHlp == View) || (FlagHlp == Hlp) )
        {
        hps = WinGetPS(WinWindowFromID(hwnd, FlagHlp));
        WinDrawBorder(hps, &rcl, 1, 1, 0, 0, DB_UP);
        WinReleasePS(hps);
        }
// 뢥 help
      if ( FlagHlp == Hlp )
        {
        struct stat buf;
        char ruls[CCHMAXPATH], rules[16];

        strcpy(rules, "Rules");
        strcat(rules, LANG);
        strcat(rules, ".htm");
        strcpy(ruls, PathExe);
        strcat(ruls, rules);
        if ( stat(ruls, &buf) != 0 ) strcpy(rules, "RulesEn.htm");
        ViewCfg(rules);
        }
// ࠭ ࠬ
      if ( FlagHlp == Save ) SaveCfg();
//   䨣
      if ( FlagHlp == New )
        {
        FormNew();
        for (i=0; i<3; i++)
          {
          sprintf(addr, "%s %s   %s %C", PgmMsg[15], StartAdr[i],
                  PgmMsg[24], 'C');
          WinSetWindowText(WinWindowFromID(hwndPage1, OINFO0_ID+i), addr);
          }
        for (i=0; i<2; i++)
          {
          sprintf(addr, "%s %s   %s %C", PgmMsg[15], StartAdr[i],
                  PgmMsg[24], 'C');
          WinSetWindowText(WinWindowFromID(hwndPage2, HINFO0_ID+i), addr);
          }
        }
// 㧨 ࠭ 䨣
      if ( FlagHlp == Open )
        {
        if ( !LoadCfg() )
          {
          WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, PgmMsg[20], ErrTitle, 0,
                        MB_OK|MB_SYSTEMMODAL|MB_ERROR);
          FormNew();
          }
        for (i=0; i<3; i++)
          {
          sprintf(addr, "%s %s   %s %C", PgmMsg[15],
                  inet_ntoa(*(struct in_addr *)&OLANaddr[i]),
                  PgmMsg[24], 'A'+OClass[i]-1);
          WinSetWindowText(WinWindowFromID(hwndPage1, OINFO0_ID+i), addr);
          }
        for (i=0; i<2; i++)
          {
          sprintf(addr, "%s %s   %s %C", PgmMsg[15],
                  inet_ntoa(*(struct in_addr *)&HLANaddr[i]),
                  PgmMsg[24], 'A'+HClass[i]-1);
          WinSetWindowText(WinWindowFromID(hwndPage2, HINFO0_ID+i), addr);
          }
        }
// ᬮ 䨣樨
      if ( FlagHlp == View )
          {
          if ( PageOfficeID == (ULONG)WinSendMsg(hwndNoteBook,
               BKM_QUERYPAGEID, NULL, (MPARAM)BKA_TOP) ) FormCfg();
          else FormCfg1();
          ViewCfg("ConfigIP.htm");
          }
      break;
      }
//-----------------------------------------------------------------------------
// WM_TIMER ᯮ㥬   ᪠
//-----------------------------------------------------------------------------
    case WM_TIMER:
      {
      POINTL ptl;
      SWP swpNew, swpOpen, swpSave, swpView, swpHelp;

      WinQueryWindowPos(hwndNew, &swpNew);
      WinQueryWindowPos(hwndOpen, &swpOpen);
      WinQueryWindowPos(hwndSave, &swpSave);
      WinQueryWindowPos(hwndView, &swpView);
      WinQueryWindowPos(hwndHelp, &swpHelp);

      WinQueryPointerPos(HWND_DESKTOP, &ptl);
      WinMapWindowPoints(HWND_DESKTOP, hwnd, &ptl, 1);

      if ( swpNew.x <= ptl.x && swpNew.x+swpNew.cx >= ptl.x &&
           swpNew.y <= ptl.y && swpNew.y + swpNew.cy >= ptl.y ) break;
      if ( swpOpen.x <= ptl.x && swpOpen.x+swpOpen.cx >= ptl.x &&
           swpOpen.y <= ptl.y && swpOpen.y + swpOpen.cy >= ptl.y ) break;
      if ( swpSave.x <= ptl.x && swpSave.x+swpSave.cx >= ptl.x &&
           swpSave.y <= ptl.y && swpSave.y + swpSave.cy >= ptl.y ) break;
      if ( swpView.x <= ptl.x && swpView.x+swpView.cx >= ptl.x &&
           swpView.y <= ptl.y && swpView.y + swpView.cy >= ptl.y ) break;
      if ( swpHelp.x <= ptl.x && swpHelp.x+swpHelp.cx >= ptl.x &&
           swpHelp.y <= ptl.y && swpHelp.y + swpHelp.cy >= ptl.y ) break;

      hps = WinGetPS(WinWindowFromID(hwnd, FlagHlp));
      WinDrawBorder(hps, &rcl, 1, 1, SYSCLR_MENU, 0, DB_STANDARD);
      WinReleasePS(hps);

      FlagHlp = FALSE;
      WinSetWindowText(hwndHelpTxt, "");
      WinStopTimer(hab, hwnd, 1);
      break;
      }
//-----------------------------------------------------------------------------
//   誨
//-----------------------------------------------------------------------------
    case WM_CONTROLPOINTER:
      {
      unsigned int idCtl = SHORT1FROMMP(mp1);

      if ( idCtl == FlagHlp ) break;
      hps = WinGetPS(WinWindowFromID(hwnd, FlagHlp));
      WinDrawBorder(hps, &rcl, 1, 1, SYSCLR_MENU, 0, DB_STANDARD);
      WinReleasePS(hps);

      if ( (idCtl == New)  || (idCtl == Open) || (idCtl == Save) ||
           (idCtl == View) || (idCtl == Hlp) )
        {
        WinSetPointer(HWND_DESKTOP, hptr);
        FlagHlp = idCtl;
        if ( idCtl == New )
          WinSetWindowText(hwndHelpTxt, PgmMsg[25]);
        if ( idCtl == Open )
          WinSetWindowText(hwndHelpTxt, PgmMsg[26]);
        if ( idCtl == Save )
          WinSetWindowText(hwndHelpTxt, PgmMsg[27]);
        if ( idCtl == View )
          WinSetWindowText(hwndHelpTxt, PgmMsg[28]);
        if ( idCtl == Hlp )
          WinSetWindowText(hwndHelpTxt, PgmMsg[10]);

        hps = WinGetPS(WinWindowFromID(hwnd, FlagHlp));
        WinDrawBorder(hps, &rcl, 1, 1, 0, 0, DB_UP);
        WinReleasePS(hps);

        WinStartTimer(hab, hwnd, 1, 50);
        return (MRESULT)TRUE;
        }
      break;
      }
//-----------------------------------------------------------------------------
// WM_PAINT occurs during every resize, size setting event
//-----------------------------------------------------------------------------
    case WM_PAINT:
      {
      RECTL rcl;
      HPS hps;

      hps = WinBeginPaint (hwnd, NULLHANDLE, &rcl) ;
      WinFillRect(hps, &rcl, SYSCLR_MENU);
      WinEndPaint(hps);
      break;
      }
//-----------------------------------------------------------------------------
// WM_SIZE occurs during every resize, size setting event
//-----------------------------------------------------------------------------
    case WM_SIZE:
      {
      SWP newSWP;
// ⠭ ࠬ   
      WinQueryWindowPos(WinQueryWindow(hwnd, QW_PARENT), (PSWP)&newSWP);
      newSWP.cx = minCX;
      newSWP.y = newSWP.y + newSWP.cy - minCY;
      newSWP.cy = minCY;
      WinSetWindowPos(WinQueryWindow(hwnd, QW_PARENT), HWND_TOP,
                      newSWP.x, newSWP.y, newSWP.cx, newSWP.cy,
                      SWP_ACTIVATE | SWP_MOVE | SWP_SIZE | SWP_SHOW);
// ࠧ⨬ ୨ 
      WinSetWindowPos(hwndHelpTxt, HWND_TOP, 0, 0, newSWP.cx, HelpCY,
                      SWP_SIZE | SWP_MOVE);
      WinSetWindowPos(hwndNoteBook, HWND_TOP, 0, HelpCY,
                      newSWP.cx, newSWP.cy-HelpCY-MenuZakl,
                     SWP_SIZE | SWP_MOVE);
      WinSetWindowPos(hwndNew, HWND_TOP, 10, newSWP.cy-ICOcy*7/5-BlankSpc,
                      ICOcx, ICOcy, SWP_SIZE | SWP_MOVE);
      WinSetWindowPos(hwndOpen, HWND_TOP, ICOcx+10, newSWP.cy-ICOcy*7/5-BlankSpc,
                      ICOcx, ICOcy, SWP_SIZE | SWP_MOVE);
      WinSetWindowPos(hwndSave, HWND_TOP, ICOcx*2+10, newSWP.cy-ICOcy*7/5-BlankSpc,
                      ICOcx, ICOcy, SWP_SIZE | SWP_MOVE);
      WinSetWindowPos(hwndView, HWND_TOP, ICOcx*3+10, newSWP.cy-ICOcy*7/5-BlankSpc,
                      ICOcx, ICOcy, SWP_SIZE | SWP_MOVE);
      WinSetWindowPos(hwndHelp,HWND_TOP,newSWP.cx-ICOcx,newSWP.cy-ICOcy*7/5-BlankSpc,
                      ICOcx, ICOcy, SWP_SIZE | SWP_MOVE);
      break;
      }
//-----------------------------------------------------------------------------
// WM_CREATE occurs only during creation
//-----------------------------------------------------------------------------
    case WM_CREATE:
      {
      long rgb_color;
      char *ptr, FontWarpSans[] = "9.WarpSans";
      int width;

// 㧭 ࠧ襭 (ਭ)   ந 
      width = WinQuerySysValue(HWND_DESKTOP, SV_CXSCREEN);
      if ( width < 960 )
        {
        minCX = 365;
        minCY = 435;
        MenuZakl = 60;
        rcl.yBottom = 0;
        BlankSpc = 0;
        Odialog = ODIALOG800_ID;
        Hdialog = HDIALOG800_ID;
        }
      else
        if ( width >= 1280 )
        {
        minCX = 575;
        minCY = 540;
        }
// ᮧ 
      hwndHelpTxt =
          WinCreateWindow(hwnd, WC_STATIC, NULL,
                          WS_VISIBLE|SS_TEXT|DT_LEFT|DT_BOTTOM,
                          0, 0, 0, 0, hwnd, HWND_TOP, HELPTXT_ID, 0, 0);
      hwndNoteBook =
          WinCreateWindow(hwnd, WC_NOTEBOOK, NULL,
                          WS_VISIBLE | BKS_TABBEDDIALOG | BKS_MAJORTABTOP |
                          BKS_BACKPAGESTR | BKS_BACKPAGESBR,
                          0, 0, 0, 0, hwnd, HWND_TOP, NOTEBOOK_ID, 0, 0);
      hwndNew =
          WinCreateWindow(hwnd, WC_STATIC, "#15", WS_VISIBLE | SS_ICON,
                          0, 0, 0, 0, hwnd, HWND_TOP, New, 0, 0);
      hwndOpen =
          WinCreateWindow(hwnd, WC_STATIC, "#16", WS_VISIBLE | SS_ICON,
                          0, 0, 0, 0, hwnd, HWND_TOP, Open, 0, 0);
      hwndSave =
          WinCreateWindow(hwnd, WC_STATIC, "#17", WS_VISIBLE | SS_ICON,
                          0, 0, 0, 0, hwnd, HWND_TOP, Save, 0, 0);
      hwndView =
          WinCreateWindow(hwnd, WC_STATIC, "#18", WS_VISIBLE | SS_ICON,
                          0, 0, 0, 0, hwnd, HWND_TOP, View, 0, 0);
      hwndHelp =
          WinCreateWindow(hwnd, WC_STATIC, "#19", WS_VISIBLE | SS_ICON,
                          0, 0, 0, 0, hwnd, HWND_TOP, Hlp, 0, 0);
      hwndPage1 = WinLoadDlg(hwnd, hwnd, ODlgMain, NULLHANDLE,
                             Odialog, NULL);
      hwndPage2 = WinLoadDlg(hwnd, hwnd, HDlgMain, NULLHANDLE,
                             Hdialog, NULL);
// ⠢ ࠭ Office
      PageOfficeID = (ULONG)WinSendMsg(hwndNoteBook, BKM_INSERTPAGE, NULL,
                     MPFROM2SHORT(BKA_AUTOPAGESIZE | BKA_MAJOR, BKA_LAST));
      WinSendMsg(hwndNoteBook, BKM_SETTABTEXT, MPFROMLONG(PageOfficeID),
                 MPFROMP(PgmMsg[23]));
      WinSendMsg(hwndNoteBook, BKM_SETPAGEWINDOWHWND,
                 MPFROMLONG(PageOfficeID), MPFROMHWND(hwndPage1));
// ⠢ ࠭ Home
      PageHomeID = (ULONG)WinSendMsg(hwndNoteBook, BKM_INSERTPAGE, NULL,
                   MPFROM2SHORT(BKA_AUTOPAGESIZE | BKA_MAJOR, BKA_LAST));
      WinSendMsg(hwndNoteBook, BKM_SETTABTEXT, MPFROMLONG(PageHomeID),
                 MPFROMP(PgmMsg[22]));
      WinSendMsg(hwndNoteBook, BKM_SETPAGEWINDOWHWND,
                 MPFROMLONG(PageHomeID), MPFROMHWND(hwndPage2));
// ⠭ ࠬ   INI 䠩
      if ( (hini = PrfOpenProfile(hab, IniName)) != NULLHANDLE )
        {
        if ( PrfQueryProfileSize(hini, AppName, WinPos, &ulSize) )
          {
          ptr = calloc(ulSize, 1);
          if ( PrfQueryProfileData(hini, AppName, WinPos, ptr, &ulSize) )
            PrfWriteProfileData(HINI_USER, AppName, WinPos, ptr, ulSize);
          free(ptr);
          }
        PrfCloseProfile(hini);   // Close private profile
        }
      if (!WinRestoreWindowPos(AppName,WinPos,WinQueryWindow(hwnd,QW_PARENT)))
        WinSetWindowPos(WinQueryWindow(hwnd, QW_PARENT), HWND_TOP,
                        0, 0, minCX, minCY,
                        SWP_ACTIVATE | SWP_MOVE | SWP_SIZE | SWP_SHOW);
      PrfWriteProfileData(HINI_USER, AppName, NULL, NULL, 0);
// Set Presentation Parameters for static text
      rgb_color = WinQuerySysColor(HWND_DESKTOP, SYSCLR_DIALOGBACKGROUND, 0);
      WinSetPresParam(hwndHelpTxt, PP_BACKGROUNDCOLOR, sizeof(RGB),
                      (PVOID)&rgb_color); // 䮭
      rgb_color = WinQuerySysColor(HWND_DESKTOP, SYSCLR_WINDOWTEXT, 0);
      WinSetPresParam(hwndHelpTxt, PP_FOREGROUNDCOLOR, sizeof(RGB),
                      (PVOID)&rgb_color); // ⥪
// Set Presentation Parameters for notebook
      WinSetPresParam(hwndNoteBook, PP_FONTNAMESIZE, sizeof(FontWarpSans),
                      FontWarpSans);
// Load pointer
      hptr = WinLoadPointer(HWND_DESKTOP, NULLHANDLE, 31);
      break;
      }
//-----------------------------------------------------------------------------
// Save the window size and position on exit
//-----------------------------------------------------------------------------
    case WM_SAVEAPPLICATION:
      {
      char *ptr;

// Check if window is minimized and restore to original size
      if ( WinQueryWindowULong(hwndFrame, QWL_STYLE) & WS_MINIMIZED )
        WinSetWindowPos(hwndFrame, HWND_TOP, 0, 0, 0, 0, SWP_RESTORE);
// Store window information in OS2.INI
      WinStoreWindowPos(AppName, WinPos, WinQueryWindow(hwnd, QW_PARENT) );
// Copy the Window position info from the OS2.INI into private INI file
      PrfQueryProfileSize(HINI_USERPROFILE, AppName, WinPos, &ulSize);
      ptr = calloc(ulSize, 1);
      PrfQueryProfileData( HINI_USERPROFILE, AppName, WinPos, ptr, &ulSize);
      PrfWriteProfileData(HINI_USERPROFILE, AppName, NULL, NULL, 0);
      hini = PrfOpenProfile(hab, IniName); // Open private profile
      PrfWriteProfileData(hini, AppName, WinPos, ptr, ulSize);
      PrfCloseProfile(hini);   // Close private profile
      free(ptr);
      break;
      }
//-----------------------------------------------------------------------------
// Fill client with default color
//-----------------------------------------------------------------------------
    case WM_ERASEBACKGROUND:
      return MRFROMSHORT(TRUE);
//-----------------------------------------------------------------------------
    }
  return(WinDefWindowProc(hwnd, msg, mp1, mp2));
}

//=============================================================================
// Dialog procedure ODlgMain
//=============================================================================
MRESULT EXPENTRY ODlgMain(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
int i;

  switch (msg)
    {
//-----------------------------------------------------------------------------
// Handle the initialization of the dialog
//-----------------------------------------------------------------------------
    case WM_INITDLG:
      {
      FormNew();

      for (i=0; i<3; i++)
        {
        sprintf(addr, "%s %s   %s %C", PgmMsg[15], StartAdr[i], PgmMsg[24], 'C');
        WinSetWindowText(WinWindowFromID(hwnd, OINFO0_ID+i), addr);
        }
      break;
      }
//-----------------------------------------------------------------------------
// ࠡ⠥ ⨥ 設 
//-----------------------------------------------------------------------------
    case WM_BUTTON1DOWN:
      {
      if ( FlagHlp == OROUTER_ID )
        {
        WinDlgBox (HWND_DESKTOP, hwnd, DlgNodeR, NULLHANDLE, DLGNODER_ID, 0);
        break;
        }
      if ( (FlagHlp == OPC1_ID) || (FlagHlp == OPC2_ID) )
        {
        PCid = FlagHlp-OPC1_ID+1; // pass as mp2 of WM_INITDLG
        WinDlgBox(HWND_DESKTOP, hwnd, DlgNodePC, NULLHANDLE,
                   DLGNODEPC_ID, (PVOID)&PCid);
        break;
        }
      if ((FlagHlp == OVM1_ID) || (FlagHlp == OVM2_ID) || (FlagHlp == OVM3_ID))
        {
        PCid = FlagHlp - OVM1_ID; // pass as mp2 of WM_INITDLG
        WinDlgBox (HWND_DESKTOP, hwnd, DlgNodeVM, NULLHANDLE,
                   DLGNODEVM_ID, (PVOID)&PCid);
        break;
        }
      if ((FlagHlp == OINFO0_ID) || (FlagHlp == OINFO1_ID) ||
          (FlagHlp == OINFO2_ID))
        {
        LANid = FlagHlp-OINFO0_ID; // pass as mp2 of WM_INITDLG
        WinDlgBox (HWND_DESKTOP, hwnd, DlgLAN, NULLHANDLE, DLGLAN_ID,
          (PVOID)&LANid);

        sprintf(addr, "%s %s   %s %C", PgmMsg[15],
                inet_ntoa(*(struct in_addr *)&OLANaddr[LANid]),
                PgmMsg[24], 'A'+OClass[LANid]-1);
        WinSetWindowText(WinWindowFromID(hwnd, OINFO0_ID+LANid), addr);

        OIPaddrR = (OIPaddrR & ~OMask[0]) | OLANaddr[0];
        OIPaddrPC1[0] = (OIPaddrPC1[0] & ~OMask[0]) | OLANaddr[0];
        OIPaddrPC1[1] = (OIPaddrPC1[1] & ~OMask[1]) | OLANaddr[1];
        OIPaddrPC2[0] = (OIPaddrPC2[0] & ~OMask[0]) | OLANaddr[0];
        OIPaddrPC2[1] = (OIPaddrPC2[1] & ~OMask[2]) | OLANaddr[2];
        OIPaddrVM[0] = (OIPaddrVM[0] & ~OMask[1]) | OLANaddr[1];
        OIPaddrVM[1] = (OIPaddrVM[1] & ~OMask[1]) | OLANaddr[1];
        OIPaddrVM[2] = (OIPaddrVM[2] & ~OMask[2]) | OLANaddr[2];
        }
      break;
      }
//-----------------------------------------------------------------------------
// WM_TIMER ᯮ㥬   ᪠
//-----------------------------------------------------------------------------
    case WM_TIMER:
      {
      POINTL ptl;
      SWP swpOR, swpOPC1, swpOPC2, swpOVM1, swpOVM2, swpOVM3, swpORLAN,
          swpOVLAN1, swpOVLAN2;

      WinQueryWindowPos(WinWindowFromID(hwnd,OROUTER_ID), &swpOR);
      WinQueryWindowPos(WinWindowFromID(hwnd,OPC1_ID), &swpOPC1);
      WinQueryWindowPos(WinWindowFromID(hwnd,OPC2_ID), &swpOPC2);
      WinQueryWindowPos(WinWindowFromID(hwnd,OVM1_ID), &swpOVM1);
      WinQueryWindowPos(WinWindowFromID(hwnd,OVM2_ID), &swpOVM2);
      WinQueryWindowPos(WinWindowFromID(hwnd,OVM3_ID), &swpOVM3);
      WinQueryWindowPos(WinWindowFromID(hwnd,OINFO0_ID), &swpORLAN);
      WinQueryWindowPos(WinWindowFromID(hwnd,OINFO1_ID), &swpOVLAN1);
      WinQueryWindowPos(WinWindowFromID(hwnd,OINFO2_ID), &swpOVLAN2);

      WinQueryPointerPos(HWND_DESKTOP, &ptl);
      WinMapWindowPoints(HWND_DESKTOP, hwnd, &ptl, 1);

      if ( swpOR.x <= ptl.x && swpOR.x+swpOR.cx >= ptl.x &&
           swpOR.y <= ptl.y && swpOR.y + swpOR.cy >= ptl.y ) break;
      if ( swpOPC1.x <= ptl.x && swpOPC1.x+swpOPC1.cx >= ptl.x &&
           swpOPC1.y <= ptl.y && swpOPC1.y + swpOPC1.cy >= ptl.y ) break;
      if ( swpOPC2.x <= ptl.x && swpOPC2.x+swpOPC2.cx >= ptl.x &&
           swpOPC2.y <= ptl.y && swpOPC2.y + swpOPC2.cy >= ptl.y ) break;
      if ( swpOVM1.x <= ptl.x && swpOVM1.x+swpOVM1.cx >= ptl.x &&
           swpOVM1.y <= ptl.y && swpOVM1.y + swpOVM1.cy >= ptl.y ) break;
      if ( swpOVM2.x <= ptl.x && swpOVM2.x+swpOVM2.cx >= ptl.x &&
           swpOVM2.y <= ptl.y && swpOVM2.y + swpOVM2.cy >= ptl.y ) break;
      if ( swpOVM3.x <= ptl.x && swpOVM3.x+swpOVM3.cx >= ptl.x &&
           swpOVM3.y <= ptl.y && swpOVM3.y + swpOVM3.cy >= ptl.y ) break;
      if ( swpORLAN.x <= ptl.x && swpORLAN.x+swpORLAN.cx >= ptl.x &&
           swpORLAN.y <= ptl.y && swpORLAN.y + swpORLAN.cy >= ptl.y ) break;
      if ( swpOVLAN1.x <= ptl.x && swpOVLAN1.x+swpOVLAN1.cx >= ptl.x &&
           swpOVLAN1.y <= ptl.y && swpOVLAN1.y + swpOVLAN1.cy >= ptl.y ) break;
      if ( swpOVLAN2.x <= ptl.x && swpOVLAN2.x+swpOVLAN2.cx >= ptl.x &&
           swpOVLAN2.y <= ptl.y && swpOVLAN2.y + swpOVLAN2.cy >= ptl.y ) break;

      FlagHlp = FALSE;
      WinSetWindowText(hwndHelpTxt, "");
      WinStopTimer(hab, hwnd, 1);
      break;
      }
//-----------------------------------------------------------------------------
//   誨
//-----------------------------------------------------------------------------
    case WM_CONTROLPOINTER:
      {
      char buf[80];
      unsigned int idCtl = SHORT1FROMMP(mp1);
      if ((idCtl == OPC1_ID) || (idCtl == OPC2_ID) || (idCtl == OROUTER_ID) ||
          (idCtl == OVM1_ID) || (idCtl == OVM2_ID) || (idCtl == OVM3_ID)    ||
          (idCtl == OINFO0_ID) || (idCtl == OINFO1_ID) || (idCtl == OINFO2_ID))
        {
        WinSetPointer(HWND_DESKTOP, hptr);
        FlagHlp = idCtl;
        if ( (idCtl == OPC1_ID) || (idCtl == OPC2_ID) )
          {
          sprintf(buf, "%s%d", PgmMsg[30], idCtl-OPC1_ID+1);
          WinSetWindowText(hwndHelpTxt, buf);
          }
        if ( (idCtl == OVM1_ID) || (idCtl == OVM2_ID) || (idCtl == OVM3_ID) )
          {
          sprintf(buf, "%s%d", PgmMsg[31], idCtl-OVM1_ID+1);
          WinSetWindowText(hwndHelpTxt, buf);
          }
        if ( idCtl == OROUTER_ID ) WinSetWindowText(hwndHelpTxt, "Router");
        if ( idCtl == OINFO0_ID ) WinSetWindowText(hwndHelpTxt, PgmMsg[8]);
        if ( (idCtl == OINFO1_ID) || (idCtl == OINFO2_ID) )
           WinSetWindowText(hwndHelpTxt, PgmMsg[7]);
        WinStartTimer(hab, hwnd, 1, 50);
        return (MRESULT)TRUE;
        }
      break;
      }
//-----------------------------------------------------------------------------
    }
  return WinDefDlgProc(hwnd, msg, mp1, mp2);
}

//=============================================================================
// Dialog procedure HDlgMain
//=============================================================================
MRESULT EXPENTRY HDlgMain(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
int i;

  switch (msg)
    {
//-----------------------------------------------------------------------------
// Handle the initialization of the dialog
//-----------------------------------------------------------------------------
    case WM_INITDLG:
      {
      FormNew();

      for (i=0; i<2; i++)
        {
        sprintf(addr, "%s %s   %s %C", PgmMsg[15], StartAdr[i], PgmMsg[24], 'C');
        WinSetWindowText(WinWindowFromID(hwnd, HINFO0_ID+i), addr);
        }
      break;
      }
//-----------------------------------------------------------------------------
// ࠡ⠥ ⨥ 設 
//-----------------------------------------------------------------------------
    case WM_BUTTON1DOWN:
      {
      if ( FlagHlp == HPC1_ID )
        {
        WinDlgBox(HWND_DESKTOP,hwnd,DlgNodePC1,NULLHANDLE,DLGNODEPC1_ID,NULL);
        break;
        }
      if ( (FlagHlp == HVM1_ID) || (FlagHlp == HVM2_ID) )
        {
        PCid = FlagHlp-HVM1_ID; // pass as mp2 of WM_INITDLG
        WinDlgBox (HWND_DESKTOP, hwnd, DlgNodeVM1, NULLHANDLE,
                   DLGNODEVM_ID, (PVOID)&PCid);
        break;
        }
      if ( (FlagHlp == HINFO0_ID) || (FlagHlp == HINFO1_ID) )
        {
        LANid = FlagHlp-HINFO0_ID; // pass as mp2 of WM_INITDLG
        WinDlgBox (HWND_DESKTOP, hwnd, DlgLAN1, NULLHANDLE,
                   DLGLAN_ID, (PVOID)&LANid);
        sprintf(addr, "%s %s   %s %C", PgmMsg[15],
                inet_ntoa(*(struct in_addr *)&HLANaddr[LANid]),
                PgmMsg[24], 'A'+HClass[LANid]-1);
        WinSetWindowText(WinWindowFromID(hwnd, HINFO0_ID+LANid), addr);

        HIPaddrPC1[0] = (HIPaddrPC1[0] & ~HMask[0]) | HLANaddr[0];
        HIPaddrPC1[1] = (HIPaddrPC1[1] & ~HMask[1]) | HLANaddr[1];
        HIPaddrVM[0] = (HIPaddrVM[0] & ~HMask[1]) | HLANaddr[1];
        HIPaddrVM[1] = (HIPaddrVM[1] & ~HMask[1]) | HLANaddr[1];
        }
      break;
      }
//-----------------------------------------------------------------------------
// WM_TIMER ᯮ㥬   ᪠
//-----------------------------------------------------------------------------
    case WM_TIMER:
      {
      POINTL ptl;
      SWP swpHPC1, swpHVM1, swpHVM2, swpHRLAN, swpHVLAN1, swpHInternet;

      WinQueryWindowPos(WinWindowFromID(hwnd,HPC1_ID), &swpHPC1);
      WinQueryWindowPos(WinWindowFromID(hwnd,HVM1_ID), &swpHVM1);
      WinQueryWindowPos(WinWindowFromID(hwnd,HVM2_ID), &swpHVM2);
      WinQueryWindowPos(WinWindowFromID(hwnd,HINFO0_ID), &swpHRLAN);
      WinQueryWindowPos(WinWindowFromID(hwnd,HINFO1_ID), &swpHVLAN1);
      WinQueryWindowPos(WinWindowFromID(hwnd,HINTERNET_ID), &swpHInternet);

      WinQueryPointerPos(HWND_DESKTOP, &ptl);
      WinMapWindowPoints(HWND_DESKTOP, hwnd, &ptl, 1);

      if ( swpHPC1.x <= ptl.x && swpHPC1.x+swpHPC1.cx >= ptl.x &&
           swpHPC1.y <= ptl.y && swpHPC1.y + swpHPC1.cy >= ptl.y ) break;
      if ( swpHVM1.x <= ptl.x && swpHVM1.x+swpHVM1.cx >= ptl.x &&
           swpHVM1.y <= ptl.y && swpHVM1.y + swpHVM1.cy >= ptl.y ) break;
      if ( swpHVM2.x <= ptl.x && swpHVM2.x+swpHVM2.cx >= ptl.x &&
           swpHVM2.y <= ptl.y && swpHVM2.y + swpHVM2.cy >= ptl.y ) break;
      if ( swpHRLAN.x <= ptl.x && swpHRLAN.x+swpHRLAN.cx >= ptl.x &&
           swpHRLAN.y <= ptl.y && swpHRLAN.y + swpHRLAN.cy >= ptl.y ) break;
      if ( swpHVLAN1.x <= ptl.x && swpHVLAN1.x+swpHVLAN1.cx >= ptl.x &&
           swpHVLAN1.y <= ptl.y && swpHVLAN1.y + swpHVLAN1.cy >= ptl.y ) break;
      if ( swpHInternet.x <= ptl.x && swpHInternet.x+swpHInternet.cx >= ptl.x &&
           swpHInternet.y <= ptl.y && swpHInternet.y + swpHInternet.cy >= ptl.y ) break;

      FlagHlp = FALSE;
      WinSetWindowText(hwndHelpTxt, "");
      WinStopTimer(hab, hwnd, 1);
      break;
      }
//-----------------------------------------------------------------------------
//   誨
//-----------------------------------------------------------------------------
    case WM_CONTROLPOINTER:
      {
      char buf[80];
      unsigned int idCtl = SHORT1FROMMP(mp1);
      if ((idCtl == HPC1_ID) || (idCtl == HVM1_ID) || (idCtl == HVM2_ID) ||
          (idCtl == HINFO0_ID) || (idCtl == HINFO1_ID) ||
          (idCtl == HINTERNET_ID))
        {
        if ( idCtl != HINTERNET_ID ) WinSetPointer(HWND_DESKTOP, hptr);
        FlagHlp = idCtl;
        if ( idCtl == HPC1_ID ) WinSetWindowText(hwndHelpTxt, PgmMsg[30]);
        if ( (idCtl == HVM1_ID) || (idCtl == HVM2_ID) )
          {
          sprintf(buf, "%s%d", PgmMsg[31], idCtl-HVM1_ID+1);
          WinSetWindowText(hwndHelpTxt, buf);
          }
        if ( idCtl == HINTERNET_ID ) WinSetWindowText(hwndHelpTxt, "Internet");
        if ( idCtl == HINFO0_ID ) WinSetWindowText(hwndHelpTxt, PgmMsg[8]);
        if ( idCtl == HINFO1_ID ) WinSetWindowText(hwndHelpTxt, PgmMsg[7]);
        WinStartTimer(hab, hwnd, 1, 50);
        return (MRESULT)TRUE;
        }
      break;
      }
    }

  return WinDefDlgProc(hwnd, msg, mp1, mp2);
}

//=============================================================================
// ViewCfg - ணࠬ 뢮 䨣樨
//=============================================================================
void ViewCfg(char *parm)
{
PROGDETAILS pd;
char Path[CCHMAXPATH] = "file:///";

  strcat(Path, PathExe);
  strcat(Path, parm);

  pd.Length          = sizeof(PROGDETAILS);
  pd.progt.progc     = PROG_DEFAULT;
  pd.progt.fbVisible = SHE_VISIBLE;
  pd.pszTitle        = NULL;
  pd.pszExecutable   = browserExe;
  pd.pszParameters   = NULL;
  pd.pszStartupDir   = browserDir;
  pd.pszIcon         = NULL;
  pd.pszEnvironment  = NULL;
  pd.swpInitial.fl   = SWP_ACTIVATE;
  pd.swpInitial.cy   = 0;
  pd.swpInitial.cx   = 0;
  pd.swpInitial.y    = 0;
  pd.swpInitial.x    = 0;
  pd.swpInitial.hwndInsertBehind = HWND_TOP;
  pd.swpInitial.hwnd             = NULLHANDLE;
  pd.swpInitial.ulReserved1      = 0;
  pd.swpInitial.ulReserved2      = 0;
  WinStartApp(NULLHANDLE, &pd, Path, NULL, 0);
}

//=============================================================================
// FormNew - ணࠬ ନ஢ 砫쭮 䨣樨
//=============================================================================
void FormNew(void)
{
int i;

  OLANaddr[0] = inet_addr(StartAdr[0]);
  OLANaddr[1] = inet_addr(StartAdr[1]);
  OLANaddr[2] = inet_addr(StartAdr[2]);

  for (i=0; i<3; i++)
    {
    OMask[i] = inet_addr(Msk[2]);
    OClass[i] = 3;
    OOS[i] = 0;
    }

  OIPaddrR = inet_addr(NodeIPaddr[0]);
  OIPaddrPC1[0] = inet_addr(NodeIPaddr[1]);
  OIPaddrPC1[1] = inet_addr(NodeIPaddr[2]);
  OIPaddrPC2[0] = inet_addr(NodeIPaddr[3]);
  OIPaddrPC2[1] = inet_addr(NodeIPaddr[4]);
  OIPaddrVM[0] = inet_addr(NodeIPaddr[5]);
  OIPaddrVM[1] = inet_addr(NodeIPaddr[6]);
  OIPaddrVM[2] = inet_addr(NodeIPaddr[7]);

  HLANaddr[0] = inet_addr(StartAdr[0]);
  HLANaddr[1] = inet_addr(StartAdr[1]);

  for (i=0; i<2; i++)
    {
    HMask[i] = inet_addr(Msk[2]);
    HClass[i] = 3;
    HOS[i] = 0;
    }

  HIPaddrPC1[0] = inet_addr(NodeIPaddr[0]);
  HIPaddrPC1[1] = inet_addr(NodeIPaddr[2]);
  HIPaddrVM[0]  = inet_addr(NodeIPaddr[5]);
  HIPaddrVM[1]  = inet_addr(NodeIPaddr[6]);
}

//=============================================================================
// FormTmpParm - ணࠬ ନ஢ ६ ࠬ஢
//=============================================================================
void FormTmpParm(void)
{
  memcpy(tOLANaddr, OLANaddr, sizeof(OLANaddr));
  memcpy(tOMask, OMask, sizeof(OMask));
  memcpy(tOClass, OClass, sizeof(OClass));
  memcpy((char *)&tOIPaddrR, (char *)&OIPaddrR, sizeof(OIPaddrR));
  memcpy(tOIPaddrPC1, OIPaddrPC1, sizeof(OIPaddrPC1));
  memcpy(tOIPaddrPC2, OIPaddrPC2, sizeof(OIPaddrPC2));
  memcpy(tOIPaddrVM, OIPaddrVM, sizeof(OIPaddrVM));

  memcpy(tHLANaddr, HLANaddr, sizeof(HLANaddr));
  memcpy(tHMask, HMask, sizeof(HMask));
  memcpy(tHClass, HClass, sizeof(HClass));
  memcpy(tHIPaddrPC1, HIPaddrPC1, sizeof(HIPaddrPC1));
  memcpy(tHIPaddrVM, HIPaddrVM, sizeof(HIPaddrVM));
}

//=============================================================================
// TestCfgIP - ணࠬ ஢ન ४⭮ 䨣樨
//=============================================================================
BOOL TestCfgIP(void)
{
  tOIPaddrR = (tOIPaddrR & ~tOMask[0]) | tOLANaddr[0];
  tOIPaddrPC1[0] = (tOIPaddrPC1[0] & ~tOMask[0]) | tOLANaddr[0];
  tOIPaddrPC1[1] = (tOIPaddrPC1[1] & ~tOMask[1]) | tOLANaddr[1];
  tOIPaddrPC2[0] = (tOIPaddrPC2[0] & ~tOMask[0]) | tOLANaddr[0];
  tOIPaddrPC2[1] = (tOIPaddrPC2[1] & ~tOMask[2]) | tOLANaddr[2];
  tOIPaddrVM[0] = (tOIPaddrVM[0] & ~tOMask[1]) | tOLANaddr[1];
  tOIPaddrVM[1] = (tOIPaddrVM[1] & ~tOMask[1]) | tOLANaddr[1];
  tOIPaddrVM[2] = (tOIPaddrVM[2] & ~tOMask[2]) | tOLANaddr[2];

  //   ࠢ 0
  if ( ( (tOIPaddrR      & ~tOMask[0]) == 0 ) ||
       ( (tOIPaddrPC1[0] & ~tOMask[0]) == 0 ) ||
       ( (tOIPaddrPC1[1] & ~tOMask[1]) == 0 ) ||
       ( (tOIPaddrPC2[0] & ~tOMask[0]) == 0 ) ||
       ( (tOIPaddrPC2[1] & ~tOMask[2]) == 0 ) ||
       ( (tOIPaddrVM[0]  & ~tOMask[1]) == 0 ) ||
       ( (tOIPaddrVM[1]  & ~tOMask[1]) == 0 ) ||
       ( (tOIPaddrVM[2]  & ~tOMask[2]) == 0 ) )
    {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, PgmMsg[3], ErrTitle, 0,
                  MB_OK|MB_SYSTEMMODAL|MB_ERROR);
    return(FALSE);
    }

  //   ࠢ broadcast 
  if ( ( (tOIPaddrR      | tOMask[0]) == 0xffffffff ) ||
       ( (tOIPaddrPC1[0] | tOMask[0]) == 0xffffffff ) ||
       ( (tOIPaddrPC1[1] | tOMask[1]) == 0xffffffff ) ||
       ( (tOIPaddrPC2[0] | tOMask[0]) == 0xffffffff ) ||
       ( (tOIPaddrPC2[1] | tOMask[2]) == 0xffffffff ) ||
       ( (tOIPaddrVM[0]  | tOMask[1]) == 0xffffffff ) ||
       ( (tOIPaddrVM[1]  | tOMask[1]) == 0xffffffff ) ||
       ( (tOIPaddrVM[2]  | tOMask[2]) == 0xffffffff ) )
    {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, PgmMsg[4], ErrTitle, 0,
                  MB_OK|MB_SYSTEMMODAL|MB_ERROR);
    return(FALSE);
    }

  // 㡫஢  㧫
  if ( (tOIPaddrR      == tOIPaddrPC1[0]) ||
       (tOIPaddrR      == tOIPaddrPC1[1]) ||
       (tOIPaddrR      == tOIPaddrPC2[0]) ||
       (tOIPaddrR      == tOIPaddrPC2[1]) ||
       (tOIPaddrR      == tOIPaddrVM[0] ) ||
       (tOIPaddrR      == tOIPaddrVM[1] ) ||
       (tOIPaddrR      == tOIPaddrVM[2] ) ||
       (tOIPaddrPC1[0] == tOIPaddrPC1[1]) ||
       (tOIPaddrPC1[0] == tOIPaddrPC2[0]) ||
       (tOIPaddrPC1[0] == tOIPaddrPC2[1]) ||
       (tOIPaddrPC1[0] == tOIPaddrVM[0] ) ||
       (tOIPaddrPC1[0] == tOIPaddrVM[1] ) ||
       (tOIPaddrPC1[0] == tOIPaddrVM[2] ) ||
       (tOIPaddrPC1[1] == tOIPaddrPC2[0]) ||
       (tOIPaddrPC1[1] == tOIPaddrPC2[1]) ||
       (tOIPaddrPC1[1] == tOIPaddrVM[0] ) ||
       (tOIPaddrPC1[1] == tOIPaddrVM[1] ) ||
       (tOIPaddrPC1[1] == tOIPaddrVM[2] ) ||
       (tOIPaddrPC2[0] == tOIPaddrPC2[1]) ||
       (tOIPaddrPC2[0] == tOIPaddrVM[0] ) ||
       (tOIPaddrPC2[0] == tOIPaddrVM[1] ) ||
       (tOIPaddrPC2[0] == tOIPaddrVM[2] ) ||
       (tOIPaddrPC2[1] == tOIPaddrVM[0] ) ||
       (tOIPaddrPC2[1] == tOIPaddrVM[1] ) ||
       (tOIPaddrPC2[1] == tOIPaddrVM[2] ) ||
       (tOIPaddrVM[0]  == tOIPaddrVM[1] ) ||
       (tOIPaddrVM[0]  == tOIPaddrVM[2] ) ||
       (tOIPaddrVM[1]  == tOIPaddrVM[2] ) )
    {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, PgmMsg[5], ErrTitle, 0,
                  MB_OK|MB_SYSTEMMODAL|MB_ERROR);
    return(FALSE);
    }

  // ஢ਬ ਭ  㣮 
  if ( tOClass[0] < tOClass[1] )
    if ( ( (tOIPaddrR      & tOMask[1]) == tOLANaddr[1] ) ||
         ( (tOIPaddrPC1[0] & tOMask[1]) == tOLANaddr[1] ) ||
         ( (tOIPaddrPC2[0] & tOMask[1]) == tOLANaddr[1] ) )
      {
      WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, PgmMsg[6], ErrTitle, 0,
                    MB_OK|MB_SYSTEMMODAL|MB_ERROR);
      return(FALSE);
      }

  if ( tOClass[0] > tOClass[1] )
    if ( ( (tOIPaddrPC1[1] & tOMask[0]) == tOLANaddr[0] ) ||
         ( (tOIPaddrVM[0]  & tOMask[0]) == tOLANaddr[0] ) ||
         ( (tOIPaddrVM[1]  & tOMask[0]) == tOLANaddr[0] ) )
      {
      WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, PgmMsg[6], ErrTitle, 0,
                    MB_OK|MB_SYSTEMMODAL|MB_ERROR);
      return(FALSE);
      }

  if ( tOClass[0] < tOClass[2] )
    if ( ( (tOIPaddrR      & tOMask[2]) == tOLANaddr[2] ) ||
         ( (tOIPaddrPC1[0] & tOMask[2]) == tOLANaddr[2] ) ||
         ( (tOIPaddrPC2[0] & tOMask[2]) == tOLANaddr[2] ) )
      {
      WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, PgmMsg[6], ErrTitle, 0,
                    MB_OK|MB_SYSTEMMODAL|MB_ERROR);
      return(FALSE);
      }

  if ( tOClass[0] > tOClass[2] )
    if ( ( (tOIPaddrPC2[1] & tOMask[0]) == tOLANaddr[0] ) ||
         ( (tOIPaddrVM[2]  & tOMask[0]) == tOLANaddr[0] ) )
      {
      WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, PgmMsg[6], ErrTitle, 0,
                    MB_OK|MB_SYSTEMMODAL|MB_ERROR);
      return(FALSE);
      }

  if ( tOClass[1] < tOClass[2] )
    if ( ( (tOIPaddrPC1[1] & tOMask[2]) == tOLANaddr[2] ) ||
         ( (tOIPaddrVM[0]  & tOMask[2]) == tOLANaddr[2] ) ||
         ( (tOIPaddrVM[1]  & tOMask[2]) == tOLANaddr[2] ) )
      {
      WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, PgmMsg[6], ErrTitle, 0,
                    MB_OK|MB_SYSTEMMODAL|MB_ERROR);
      return(FALSE);
      }

  if ( tOClass[1] > tOClass[2] )
    if ( ( (tOIPaddrPC2[1] & tOMask[1]) == tOLANaddr[1] ) ||
         ( (tOIPaddrVM[2]  & tOMask[1]) == tOLANaddr[1] ) )
      {
      WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, PgmMsg[6], ErrTitle, 0,
                    MB_OK|MB_SYSTEMMODAL|MB_ERROR);
      return(FALSE);
      }

  return(TRUE);
}

//=============================================================================
// DlgNodeR - ணࠬ  IP- 㧫 Router
//=============================================================================
MRESULT EXPENTRY DlgNodeR(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
static char IPaddr[16];
char *p, buf[4];
u_long IP, IPtemp;
int i, j;

  switch (msg)
    {
//-----------------------------------------------------------------------------
// Init the dialog
//-----------------------------------------------------------------------------
    case WM_INITDLG:
      {
      FormTmpParm();

      WinSetWindowText(WinWindowFromID(hwnd, IPaddrTxt_ID), PgmMsg[16]);

      for (p = (unsigned char *)&OIPaddrR, i=0; i<4; i++)
        {
        WinSendDlgItemMsg(hwnd, BYTE1_ID+i, EM_SETTEXTLIMIT, (MPARAM)3, 0);
        j = *(p+i);
        _itoa(j, buf, 10);
        WinSetDlgItemText(hwnd, BYTE1_ID+i, buf);
        if ( i >= OClass[0] )
          {
          WinSendDlgItemMsg(hwnd,BYTE1_ID+i,EM_SETREADONLY,(MPARAM)FALSE, 0);
          WinSetPresParam(WinWindowFromID(hwnd, BYTE1_ID+i),
                          PP_FOREGROUNDCOLORINDEX,
                          sizeof(ColorBlack), (PVOID)&ColorRed);
          }
        else
          {
          WinSendDlgItemMsg(hwnd, BYTE1_ID+i, EM_SETREADONLY, (MPARAM)TRUE, 0);
          WinSetPresParam(WinWindowFromID(hwnd, BYTE1_ID+i),
                          PP_FOREGROUNDCOLORINDEX,
                          sizeof(ColorRed), (PVOID)&ColorBlack);
          }
        }
      break;
      }
//-----------------------------------------------------------------------------
// Handle WM_COMMAND
//-----------------------------------------------------------------------------
    case WM_COMMAND:
      {
      switch(SHORT1FROMMP(mp1))
        {
        case DID_OK:
          {
          strcpy(IPaddr, "");
          for (i=0; i<4; i++)
            {
            WinQueryDlgItemText(hwnd, BYTE1_ID+i, 4, buf);
            strcat(IPaddr, buf);
            strcat(IPaddr, ".");
            }
          IPaddr[strlen(IPaddr)-1] = '\0';

          if ( (IP=inet_addr(IPaddr)) == INADDR_NONE )
            {
            WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, PgmMsg[0], ErrTitle, 0,
                          MB_OK|MB_SYSTEMMODAL|MB_ERROR);
            WinSetFocus(HWND_DESKTOP, WinWindowFromID(hwnd,
                        BYTE1_ID+OClass[0]));
            return(0);
            }

          tOIPaddrR = IP;
          if ( !TestCfgIP() )
            { // ஢ઠ  諠
            WinSetFocus(HWND_DESKTOP,
                        WinWindowFromID(hwnd, BYTE1_ID+OClass[0]));
            return(0);
            }

          OIPaddrR = IP;
          break;
          }
        }
      }
    break;
    }
  return (WinDefDlgProc (hwnd,msg,mp1,mp2));
}

//=============================================================================
// DlgNodePC - ணࠬ  IP- 㧫 PC
//=============================================================================
MRESULT EXPENTRY DlgNodePC(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
static char IPaddr0[16], IPaddr1[16];
char *p, buf[4];
u_long IP0, IP1, IPtemp;
static u_long *adr, *tadr;
static short ind;
int i, j;

  switch (msg)
    {
//-----------------------------------------------------------------------------
// Init the dialog
//-----------------------------------------------------------------------------
    case WM_INITDLG:
      {
      ind = *(PSHORT)mp2;
      FormTmpParm();

      WinSetWindowText(WinWindowFromID(hwnd, IPaddrTxt_ID), PgmMsg[16]);
      WinSetWindowText(WinWindowFromID(hwnd, LAN0txt_ID), PgmMsg[17]);
      WinSetWindowText(WinWindowFromID(hwnd, LAN1txt_ID), PgmMsg[18]);

      if (ind == 1)
        {
        adr = &OIPaddrPC1[0];
        tadr = &tOIPaddrPC1[0];
        }
      else
        {
        adr = &OIPaddrPC2[0];
        tadr = &tOIPaddrPC2[0];
        }

      for (p = (unsigned char *)adr, i=0; i<4; i++)
        {
        WinSendDlgItemMsg(hwnd, BYTE1_ID+i, EM_SETTEXTLIMIT, (MPARAM)3, 0);
        j = *(p+i);
        _itoa(j, buf, 10);
        WinSetDlgItemText(hwnd, BYTE1_ID+i, buf);
        if ( i >= OClass[0] )
          {
          WinSendDlgItemMsg(hwnd,BYTE1_ID+i,EM_SETREADONLY,(MPARAM)FALSE,0);
          WinSetPresParam(WinWindowFromID(hwnd, BYTE1_ID+i),
                          PP_FOREGROUNDCOLORINDEX,
                          sizeof(ColorBlack), (PVOID)&ColorRed);
          }
        else
          {
          WinSendDlgItemMsg(hwnd, BYTE1_ID+i, EM_SETREADONLY, (MPARAM)TRUE, 0);
          WinSetPresParam(WinWindowFromID(hwnd, BYTE1_ID+i),
                          PP_FOREGROUNDCOLORINDEX,
                          sizeof(ColorRed), (PVOID)&ColorBlack);
          }
        }

      for (p = (unsigned char *)(adr+1), i=0; i<4; i++)
        {
        WinSendDlgItemMsg(hwnd, BYTE01_ID+i, EM_SETTEXTLIMIT, (MPARAM)3, 0);
        j = *(p+i);
        _itoa(j, buf, 10);
        WinSetDlgItemText(hwnd, BYTE01_ID+i, buf);
        if ( i >= OClass[ind] )
          {
          WinSendDlgItemMsg(hwnd,BYTE01_ID+i,EM_SETREADONLY,(MPARAM)FALSE,0);
          WinSetPresParam(WinWindowFromID(hwnd, BYTE01_ID+i),
                          PP_FOREGROUNDCOLORINDEX,
                          sizeof(ColorBlack), (PVOID)&ColorRed);
          }
        else
          {
          WinSendDlgItemMsg(hwnd,BYTE01_ID+i,EM_SETREADONLY,(MPARAM)TRUE,0);
          WinSetPresParam(WinWindowFromID(hwnd, BYTE01_ID+i),
                          PP_FOREGROUNDCOLORINDEX,
                          sizeof(ColorRed), (PVOID)&ColorBlack);
          }
        }

      break;
      }
//-----------------------------------------------------------------------------
// Handle WM_COMMAND
//-----------------------------------------------------------------------------
    case WM_COMMAND:
      {
      switch(SHORT1FROMMP(mp1))
        {
        case DID_OK:
          {
          strcpy(IPaddr0, "");
          for (i=0; i<4; i++)
            {
            WinQueryDlgItemText(hwnd, BYTE1_ID+i, 4, buf);
            strcat(IPaddr0, buf);
            strcat(IPaddr0, ".");
            }
          IPaddr0[strlen(IPaddr0)-1] = '\0';

          strcpy(IPaddr1, "");
          for (i=0; i<4; i++)
            {
            WinQueryDlgItemText(hwnd, BYTE01_ID+i, 4, buf);
            strcat(IPaddr1, buf);
            strcat(IPaddr1, ".");
            }
          IPaddr1[strlen(IPaddr1)-1] = '\0';

          if ( (IP0=inet_addr(IPaddr0)) == INADDR_NONE )
            {
            WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, PgmMsg[0], ErrTitle, 0,
                          MB_OK|MB_SYSTEMMODAL|MB_ERROR);
            WinSetFocus(HWND_DESKTOP,WinWindowFromID(hwnd,BYTE1_ID+OClass[0]));
            return(0);
            }

          if ( (IP1=inet_addr(IPaddr1)) == INADDR_NONE )
            {
            WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, PgmMsg[0], ErrTitle, 0,
                          MB_OK|MB_SYSTEMMODAL|MB_ERROR);
            WinSetFocus(HWND_DESKTOP,
                        WinWindowFromID(hwnd, BYTE01_ID+OClass[ind]));
            return(0);
            }

          *tadr =  IP0;
          *(tadr+1) =  IP1;
          if ( !TestCfgIP() ) return(0);

          *adr =  IP0;
          *(adr+1) =  IP1;

          break;
          }
        }
      }
      break;
    }
  return (WinDefDlgProc (hwnd,msg,mp1,mp2));
}

//=============================================================================
// DlgNodeVM - ணࠬ  IP- 㧫 VM
//=============================================================================
MRESULT EXPENTRY DlgNodeVM(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
static char IPaddr[16];
static int OStemp, index;
char *p, buf[4];
u_long IP, IPtemp;
static short ind;
int i, j;

  switch (msg)
    {
//-----------------------------------------------------------------------------
// Init the dialog
//-----------------------------------------------------------------------------
    case WM_INITDLG:
      {
      ind = *(PSHORT)mp2;
      FormTmpParm();

      WinSetWindowText(WinWindowFromID(hwnd, IPaddrTxt_ID), PgmMsg[16]);

      if ( ind < 2 ) index = 1;
      else index = 2;

      for (p = (unsigned char *)&OIPaddrVM[ind], i=0; i<4; i++)
        {
        WinSendDlgItemMsg(hwnd, BYTE1_ID+i, EM_SETTEXTLIMIT, (MPARAM)3, 0);
        j = *(p+i);
        _itoa(j, buf, 10);
        WinSetDlgItemText(hwnd, BYTE1_ID+i, buf);
        if ( i >= OClass[index] )
          {
          WinSendDlgItemMsg(hwnd,BYTE1_ID+i,EM_SETREADONLY,(MPARAM)FALSE,0);
          WinSetPresParam(WinWindowFromID(hwnd, BYTE1_ID+i),
                          PP_FOREGROUNDCOLORINDEX,
                          sizeof(ColorBlack), (PVOID)&ColorRed);
          }
        else
          {
          WinSendDlgItemMsg(hwnd, BYTE1_ID+i, EM_SETREADONLY, (MPARAM)TRUE, 0);
          WinSetPresParam(WinWindowFromID(hwnd, BYTE1_ID+i),
                          PP_FOREGROUNDCOLORINDEX,
                          sizeof(ColorRed), (PVOID)&ColorBlack);
          }
        }
      OStemp = OOS[ind];
      WinCheckButton(hwnd, RBecs_ID+OStemp, TRUE);

      break;
      }
//-----------------------------------------------------------------------------
// Handle WM_CONTROL
//-----------------------------------------------------------------------------
    case WM_CONTROL:
      {
      switch(SHORT1FROMMP(mp1))
        {
//-----------------------------------------------------------------------------
// 樮 ⥬
//-----------------------------------------------------------------------------
        case RBecs_ID:
        case RBlin_ID:
        case RBwin_ID:
          {
          OStemp = SHORT1FROMMP(mp1) - RBecs_ID;
          return (0);
          }
        }
      break;
      }
//-----------------------------------------------------------------------------
// Handle WM_COMMAND
//-----------------------------------------------------------------------------
    case WM_COMMAND:
      {
      switch(SHORT1FROMMP(mp1))
        {
        case DID_OK:
          {
          strcpy(IPaddr, "");
          for (i=0; i<4; i++)
            {
            WinQueryDlgItemText(hwnd, BYTE1_ID+i, 4, buf);
            strcat(IPaddr, buf);
            strcat(IPaddr, ".");
            }
          IPaddr[strlen(IPaddr)-1] = '\0';

          if ( (IP=inet_addr(IPaddr)) == INADDR_NONE )
            {
            WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, PgmMsg[0], ErrTitle, 0,
                          MB_OK|MB_SYSTEMMODAL|MB_ERROR);
            WinSetFocus(HWND_DESKTOP, WinWindowFromID(hwnd,
                        BYTE1_ID+OClass[index]));
            return(0);
            }

          tOIPaddrVM[ind] = IP;
          if ( !TestCfgIP() )
            { // ஢ઠ  諠
            WinSetFocus(HWND_DESKTOP, WinWindowFromID(hwnd,
                        BYTE1_ID+OClass[index]));
            return(0);
            }

          OIPaddrVM[ind] = IP;
          OOS[ind] = OStemp;
          break;
          }
        }
      }
      break;
    }
  return (WinDefDlgProc (hwnd,msg,mp1,mp2));
}

//=============================================================================
// DlgLAN - ணࠬ  IP- 
//=============================================================================
MRESULT EXPENTRY DlgLAN(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
char IPaddr[16], *p, buf[4];
u_long IP;
static short ind;
static USHORT ClassTmp;
static u_long MaskTmp;
static u_long LANaddrTmp;
int i, k;

  switch (msg)
    {
//-----------------------------------------------------------------------------
// Init the dialog
//-----------------------------------------------------------------------------
    case WM_INITDLG:
      {
      ind = *(PSHORT)mp2;
      FormTmpParm();

      WinSetWindowText(WinWindowFromID(hwnd, IPaddrTxt_ID), PgmMsg[14]);
      WinSetWindowText(WinWindowFromID(hwnd, NetNumbTxt_ID), PgmMsg[15]);

      MaskTmp = OMask[ind];
      ClassTmp = OClass[ind];
      LANaddrTmp = OLANaddr[ind];
      WinCheckButton(hwnd, RBA_ID+ClassTmp-1, TRUE);

      for (p = (unsigned char *)&LANaddrTmp, i=0; i<4; i++)
        {
        WinSendDlgItemMsg(hwnd, BYTE1_ID+i, EM_SETTEXTLIMIT, (MPARAM)3, 0);

        if ( i >= ClassTmp )
          {
          WinSendDlgItemMsg(hwnd, BYTE1_ID+i, EM_SETREADONLY, (MPARAM)TRUE, 0);
          WinSetPresParam(WinWindowFromID(hwnd, BYTE1_ID+i),
                          PP_FOREGROUNDCOLORINDEX,
                          sizeof(ColorBlack), (PVOID)&ColorBlack);
          }
        else
          {
          WinSendDlgItemMsg(hwnd,BYTE1_ID+i,EM_SETREADONLY,(MPARAM)FALSE,0);
          WinSetPresParam(WinWindowFromID(hwnd, BYTE1_ID+i),
                          PP_FOREGROUNDCOLORINDEX,
                          sizeof(ColorRed), (PVOID)&ColorRed);
          }

        k = *(p+i);
        _itoa(k, &buf[0], 10);
        WinSetDlgItemText(hwnd, BYTE1_ID+i, buf);
        }

      break;
      }
//-----------------------------------------------------------------------------
// Handle WM_CONTROL
//-----------------------------------------------------------------------------
    case WM_CONTROL:
      {
      switch(SHORT1FROMMP(mp1))
        {
//-----------------------------------------------------------------------------
// Network class
//-----------------------------------------------------------------------------
        case RBA_ID:
        case RBB_ID:
        case RBC_ID:
          {
          ClassTmp = SHORT1FROMMP(mp1) - RBA_ID + 1;
          MaskTmp = inet_addr(Msk[SHORT1FROMMP(mp1)-RBA_ID]);

          for (p = (unsigned char *)&LANaddrTmp, i=0; i<4; i++)
            {
            if ( i >= ClassTmp )
              {
              *(p+i) = '\0';
              WinSendDlgItemMsg(hwnd,BYTE1_ID+i,EM_SETREADONLY,(MPARAM)TRUE,0);
              WinSetPresParam(WinWindowFromID(hwnd, BYTE1_ID+i),
                              PP_FOREGROUNDCOLORINDEX,
                              sizeof(ColorBlack), (PVOID)&ColorBlack);
              }
            else
              {
              WinSendDlgItemMsg(hwnd, BYTE1_ID+i, EM_SETREADONLY,
                                (MPARAM)FALSE, 0);
              WinSetPresParam(WinWindowFromID(hwnd, BYTE1_ID+i),
                              PP_FOREGROUNDCOLORINDEX,
                              sizeof(ColorBlack), (PVOID)&ColorRed);
              }
            k = *(p+i);
            _itoa(k, &buf[0], 10);
            WinSetDlgItemText(hwnd, BYTE1_ID+i, buf);
            }

          return (0);
          }
        }
      break;
      }
//-----------------------------------------------------------------------------
// Handle WM_COMMAND
//-----------------------------------------------------------------------------
    case WM_COMMAND:
      {
      switch(SHORT1FROMMP(mp1))
        {
        case DID_OK:
          {
          strcpy(IPaddr, "");
          for (i=0; i<4; i++)
            {
            WinQueryDlgItemText(hwnd, BYTE1_ID+i, 4, buf);
            strcat(IPaddr, buf);
            strcat(IPaddr, ".");
            }
          IPaddr[strlen(IPaddr)-1] = '\0';

          if ( (IP=inet_addr(IPaddr)) == INADDR_NONE )
            {
            WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, PgmMsg[0], ErrTitle, 0,
                          MB_OK|MB_SYSTEMMODAL|MB_ERROR);
            WinSetFocus(HWND_DESKTOP, WinWindowFromID(hwnd, BYTE1_ID));
            return(0);
            }

          p = (unsigned char *)&IP;
          if ( (*p == '\0') || (*p == 127) || (*p > 223) )
            { //   稭  0  127   223
            WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, PgmMsg[1], ErrTitle, 0,
                          MB_OK|MB_SYSTEMMODAL|MB_ERROR);
            WinSetFocus(HWND_DESKTOP, WinWindowFromID(hwnd, BYTE1_ID));
            return(0);
            }

          IP &= MaskTmp;
          for (i=0; i<3; i++)
            if ( (i != ind) && (IP == OLANaddr[i]) )
              { // 㡫஢  
              WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, PgmMsg[2], ErrTitle, 0,
                            MB_OK|MB_SYSTEMMODAL|MB_ERROR);
              WinSetFocus(HWND_DESKTOP, WinWindowFromID(hwnd, BYTE1_ID));
              return(0);
              }

          tOLANaddr[ind] = IP;
          tOClass[ind] = ClassTmp;
          tOMask[ind] = MaskTmp;
          if ( !TestCfgIP() )
            { // ஢ઠ  諠
            WinSetFocus(HWND_DESKTOP, WinWindowFromID(hwnd, BYTE1_ID));
            return(0);
            }

          OLANaddr[ind] = IP;
          OClass[ind] = ClassTmp;
          OMask[ind] = MaskTmp;

          break;
          }
        }
      }
      break;
    }
  return (WinDefDlgProc (hwnd,msg,mp1,mp2));
}

//=============================================================================
// DlgNodePC1 - ணࠬ  IP- 㧫 PC
//=============================================================================
MRESULT EXPENTRY DlgNodePC1(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
static char IPaddr0[16], IPaddr1[16];
char *p, buf[4];
u_long IP0, IP1, IPtemp;
static u_long *adr, *tadr;
static int NatTmp;
int i, j;

  switch (msg)
    {
//-----------------------------------------------------------------------------
// Init the dialog
//-----------------------------------------------------------------------------
    case WM_INITDLG:
      {
      FormTmpParm();

      WinSetWindowText(WinWindowFromID(hwnd, IPaddrTxt_ID), PgmMsg[16]);
      WinSetWindowText(WinWindowFromID(hwnd, LAN0txt_ID), PgmMsg[17]);
      WinSetWindowText(WinWindowFromID(hwnd, LAN1txt_ID), PgmMsg[18]);

      adr = &HIPaddrPC1[0];
      tadr = &tHIPaddrPC1[0];

      for (p = (unsigned char *)adr, i=0; i<4; i++)
        {
        WinSendDlgItemMsg(hwnd, BYTE1_ID+i, EM_SETTEXTLIMIT, (MPARAM)3, 0);
        j = *(p+i);
        _itoa(j, buf, 10);
        WinSetDlgItemText(hwnd, BYTE1_ID+i, buf);
        if ( i >= HClass[0] )
          {
          WinSendDlgItemMsg(hwnd, BYTE1_ID+i, EM_SETREADONLY, (MPARAM)FALSE, 0);
          WinSetPresParam(WinWindowFromID(hwnd, BYTE1_ID+i),
                          PP_FOREGROUNDCOLORINDEX,
                          sizeof(ColorBlack), (PVOID)&ColorRed);
          }
        else
          {
          WinSendDlgItemMsg(hwnd, BYTE1_ID+i, EM_SETREADONLY, (MPARAM)TRUE, 0);
          WinSetPresParam(WinWindowFromID(hwnd, BYTE1_ID+i),
                          PP_FOREGROUNDCOLORINDEX,
                          sizeof(ColorRed), (PVOID)&ColorBlack);
          }
        }

      for (p = (unsigned char *)(adr+1), i=0; i<4; i++)
        {
        WinSendDlgItemMsg(hwnd, BYTE01_ID+i, EM_SETTEXTLIMIT, (MPARAM)3, 0);
        j = *(p+i);
        _itoa(j, buf, 10);
        WinSetDlgItemText(hwnd, BYTE01_ID+i, buf);
        if ( i >= HClass[1] )
          {
          WinSendDlgItemMsg(hwnd,BYTE01_ID+i,EM_SETREADONLY,(MPARAM)FALSE,0);
          WinSetPresParam(WinWindowFromID(hwnd, BYTE01_ID+i),
                          PP_FOREGROUNDCOLORINDEX,
                          sizeof(ColorBlack), (PVOID)&ColorRed);
          }
        else
          {
          WinSendDlgItemMsg(hwnd,BYTE01_ID+i,EM_SETREADONLY,(MPARAM)TRUE,0);
          WinSetPresParam(WinWindowFromID(hwnd, BYTE01_ID+i),
                          PP_FOREGROUNDCOLORINDEX,
                          sizeof(ColorRed), (PVOID)&ColorBlack);
          }
        }

      NatTmp = Nat;
      WinCheckButton(hwnd, RBnat_ID+NatTmp-1, TRUE);

      break;
      }
//-----------------------------------------------------------------------------
// Handle WM_CONTROL
//-----------------------------------------------------------------------------
    case WM_CONTROL:
      {
      switch(SHORT1FROMMP(mp1))
        {
        case RBnat_ID:
        case RBproxy_ID:
        case RBsocks_ID:
          {
          NatTmp = SHORT1FROMMP(mp1) - RBnat_ID + 1;
          return (0);
          }
        }
      break;
      }
//-----------------------------------------------------------------------------
// Handle WM_COMMAND
//-----------------------------------------------------------------------------
    case WM_COMMAND:
      {
      switch(SHORT1FROMMP(mp1))
        {
        case DID_OK:
          {
          strcpy(IPaddr0, "");
          for (i=0; i<4; i++)
            {
            WinQueryDlgItemText(hwnd, BYTE1_ID+i, 4, buf);
            strcat(IPaddr0, buf);
            strcat(IPaddr0, ".");
            }
          IPaddr0[strlen(IPaddr0)-1] = '\0';

          strcpy(IPaddr1, "");
          for (i=0; i<4; i++)
            {
            WinQueryDlgItemText(hwnd, BYTE01_ID+i, 4, buf);
            strcat(IPaddr1, buf);
            strcat(IPaddr1, ".");
            }
          IPaddr1[strlen(IPaddr1)-1] = '\0';

          if ( (IP0=inet_addr(IPaddr0)) == INADDR_NONE )
            {
            WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, PgmMsg[0], ErrTitle, 0,
                          MB_OK|MB_SYSTEMMODAL|MB_ERROR);
            WinSetFocus(HWND_DESKTOP, WinWindowFromID(hwnd,BYTE1_ID+HClass[0]));
            return(0);
            }

          if ( (IP0=inet_addr(IPaddr0)) == INADDR_NONE )
            {
            WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, PgmMsg[0], ErrTitle, 0,
                          MB_OK|MB_SYSTEMMODAL|MB_ERROR);
            WinSetFocus(HWND_DESKTOP, WinWindowFromID(hwnd,BYTE1_ID+HClass[0]));
            return(0);
            }

          if ( (IP1=inet_addr(IPaddr1)) == INADDR_NONE )
            {
            WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, PgmMsg[0], ErrTitle, 0,
                          MB_OK|MB_SYSTEMMODAL|MB_ERROR);
            WinSetFocus(HWND_DESKTOP,
                        WinWindowFromID(hwnd,BYTE01_ID+HClass[1]));
            return(0);
            }

          *tadr =  IP0;
          *(tadr+1) =  IP1;
          if ( !TestCfgIP1() ) return(0);

          *adr =  IP0;
          *(adr+1) =  IP1;
          Nat = NatTmp;

          break;
          }
        }
      }
      break;
    }
  return (WinDefDlgProc (hwnd,msg,mp1,mp2));
}

//=============================================================================
// TestCfgIP1 - ணࠬ ஢ન ४⭮ 䨣樨
//=============================================================================
BOOL TestCfgIP1(void)
{
  tHIPaddrPC1[0] = (tHIPaddrPC1[0] & ~tHMask[0]) | tHLANaddr[0];
  tHIPaddrPC1[1] = (tHIPaddrPC1[1] & ~tHMask[1]) | tHLANaddr[1];
  tHIPaddrVM[0] = (tHIPaddrVM[0] & ~tHMask[1]) | tHLANaddr[1];
  tHIPaddrVM[1] = (tHIPaddrVM[1] & ~tHMask[1]) | tHLANaddr[1];

  //   ࠢ 0
  if ( ( (tHIPaddrPC1[0] & ~tHMask[0]) == 0 ) ||
       ( (tHIPaddrPC1[1] & ~tHMask[1]) == 0 ) ||
       ( (tHIPaddrVM[0]  & ~tHMask[1]) == 0 ) ||
       ( (tHIPaddrVM[1]  & ~tHMask[1]) == 0 ) )
    {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, PgmMsg[3], ErrTitle, 0,
                  MB_OK|MB_SYSTEMMODAL|MB_ERROR);
    return(FALSE);
    }

  //   ࠢ broadcast 
  if ( ( (tHIPaddrPC1[0] | tHMask[0]) == 0xffffffff ) ||
       ( (tHIPaddrPC1[1] | tHMask[1]) == 0xffffffff ) ||
       ( (tHIPaddrVM[0]  | tHMask[1]) == 0xffffffff ) ||
       ( (tHIPaddrVM[1]  | tHMask[1]) == 0xffffffff ) )
    {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, PgmMsg[4], ErrTitle, 0,
                  MB_OK|MB_SYSTEMMODAL|MB_ERROR);
    return(FALSE);
    }

  // 㡫஢  㧫
  if ( (tHIPaddrPC1[0] == tHIPaddrPC1[1]) ||
       (tHIPaddrPC1[0] == tHIPaddrVM[0] ) ||
       (tHIPaddrPC1[0] == tHIPaddrVM[1] ) ||
       (tHIPaddrPC1[1] == tHIPaddrVM[0] ) ||
       (tHIPaddrPC1[1] == tHIPaddrVM[1] ) ||
       (tHIPaddrVM[0]  == tHIPaddrVM[1] ) )
    {
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, PgmMsg[5], ErrTitle, 0,
                  MB_OK|MB_SYSTEMMODAL|MB_ERROR);
    return(FALSE);
    }

  return(TRUE);
}

//=============================================================================
// DlgNodeVM1 - ணࠬ  IP- 㧫 VM
//=============================================================================
MRESULT EXPENTRY DlgNodeVM1(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
static char IPaddr[16];
static int OStemp, index;
char *p, buf[4];
u_long IP, IPtemp;
static short ind;
int i, j;

  switch (msg)
    {
//-----------------------------------------------------------------------------
// Init the dialog
//-----------------------------------------------------------------------------
    case WM_INITDLG:
      {
      ind = *(PSHORT)mp2;
      FormTmpParm();

      WinSetWindowText(WinWindowFromID(hwnd, IPaddrTxt_ID), PgmMsg[16]);

      if ( ind < 2 ) index = 1;
      else index = 2;

      for (p = (unsigned char *)&HIPaddrVM[ind], i=0; i<4; i++)
        {
        WinSendDlgItemMsg(hwnd, BYTE1_ID+i, EM_SETTEXTLIMIT, (MPARAM)3, 0);
        j = *(p+i);
        _itoa(j, buf, 10);
        WinSetDlgItemText(hwnd, BYTE1_ID+i, buf);
        if ( i >= HClass[index] )
          {
          WinSendDlgItemMsg(hwnd,BYTE1_ID+i,EM_SETREADONLY,(MPARAM)FALSE,0);
          WinSetPresParam(WinWindowFromID(hwnd, BYTE1_ID+i),
                          PP_FOREGROUNDCOLORINDEX,
                          sizeof(ColorBlack), (PVOID)&ColorRed);
          }
        else
          {
          WinSendDlgItemMsg(hwnd, BYTE1_ID+i, EM_SETREADONLY, (MPARAM)TRUE, 0);
          WinSetPresParam(WinWindowFromID(hwnd, BYTE1_ID+i),
                          PP_FOREGROUNDCOLORINDEX,
                          sizeof(ColorRed), (PVOID)&ColorBlack);
          }
        }
      OStemp = HOS[ind];
      WinCheckButton(hwnd, RBecs_ID+OStemp, TRUE);

      break;
      }
//-----------------------------------------------------------------------------
// Handle WM_CONTROL
//-----------------------------------------------------------------------------
    case WM_CONTROL:
      {
      switch(SHORT1FROMMP(mp1))
        {
//-----------------------------------------------------------------------------
// Operation system
//-----------------------------------------------------------------------------
        case RBecs_ID:
        case RBlin_ID:
        case RBwin_ID:
          {
          OStemp = SHORT1FROMMP(mp1) - RBecs_ID;
          return (0);
          }
        }
      break;
      }
//-----------------------------------------------------------------------------
// Handle WM_COMMAND
//-----------------------------------------------------------------------------
    case WM_COMMAND:
      {
      switch(SHORT1FROMMP(mp1))
        {
        case DID_OK:
          {
          strcpy(IPaddr, "");
          for (i=0; i<4; i++)
            {
            WinQueryDlgItemText(hwnd, BYTE1_ID+i, 4, buf);
            strcat(IPaddr, buf);
            strcat(IPaddr, ".");
            }
          IPaddr[strlen(IPaddr)-1] = '\0';

          if ( (IP=inet_addr(IPaddr)) == INADDR_NONE )
            {
            WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, PgmMsg[0], ErrTitle, 0,
                          MB_OK|MB_SYSTEMMODAL|MB_ERROR);
            WinSetFocus(HWND_DESKTOP,
                        WinWindowFromID(hwnd, BYTE1_ID+HClass[index]));
            return(0);
            }

          tHIPaddrVM[ind] = IP;
          if ( !TestCfgIP1() )
            { // ஢ઠ  諠
            WinSetFocus(HWND_DESKTOP,
                        WinWindowFromID(hwnd, BYTE1_ID+HClass[index]));
            return(0);
            }

          HIPaddrVM[ind] = IP;
          HOS[ind] = OStemp;
          break;
          }
        }
      }
      break;
    }
  return (WinDefDlgProc (hwnd,msg,mp1,mp2));
}

//=============================================================================
// DlgLAN1 - ணࠬ  IP- 
//=============================================================================
MRESULT EXPENTRY DlgLAN1(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
char IPaddr[16], *p, buf[4];
u_long IP;
static short ind;
static USHORT ClassTmp;
static u_long MaskTmp;
static u_long LANaddrTmp;
int i, k;

  switch (msg)
    {
//-----------------------------------------------------------------------------
// Init the dialog
//-----------------------------------------------------------------------------
    case WM_INITDLG:
      {
      ind = *(PSHORT)mp2;
      FormTmpParm();

      WinSetWindowText(WinWindowFromID(hwnd, IPaddrTxt_ID), PgmMsg[14]);
      WinSetWindowText(WinWindowFromID(hwnd, NetNumbTxt_ID), PgmMsg[15]);

      MaskTmp = HMask[ind];
      ClassTmp = HClass[ind];
      LANaddrTmp = HLANaddr[ind];
      WinCheckButton(hwnd, RBA_ID+ClassTmp-1, TRUE);

      for (p = (unsigned char *)&LANaddrTmp, i=0; i<4; i++)
        {
        k = *(p+i);
        _itoa(k, &buf[0], 10);
        WinSetDlgItemText(hwnd, BYTE1_ID+i, buf);

        WinSendDlgItemMsg(hwnd, BYTE1_ID+i, EM_SETTEXTLIMIT, (MPARAM)3, 0);
        WinSendDlgItemMsg(hwnd, BYTE1_ID+i, EM_SETREADONLY, (MPARAM)TRUE, 0);
        WinSetPresParam(WinWindowFromID(hwnd, BYTE1_ID+i),
                        PP_FOREGROUNDCOLORINDEX,
                        sizeof(ColorBlack), (PVOID)&ColorBlack);
        }

      if ( (ClassTmp == 2) || (ClassTmp == 3) )
        {
        WinSendDlgItemMsg(hwnd, BYTE1_ID+ClassTmp-1,
                          EM_SETREADONLY, (MPARAM)FALSE, 0);
        WinSetPresParam(WinWindowFromID(hwnd, BYTE1_ID+ClassTmp-1),
                        PP_FOREGROUNDCOLORINDEX,
                        sizeof(ColorRed), (PVOID)&ColorRed);
        }

      break;
      }
//-----------------------------------------------------------------------------
// Handle WM_CONTROL
//-----------------------------------------------------------------------------
    case WM_CONTROL:
      {
      switch(SHORT1FROMMP(mp1))
        {
//-----------------------------------------------------------------------------
// Network class
//-----------------------------------------------------------------------------
        case RBA_ID:
        case RBB_ID:
        case RBC_ID:
          {
          ClassTmp = SHORT1FROMMP(mp1) - RBA_ID + 1;
          MaskTmp = inet_addr(Msk[SHORT1FROMMP(mp1)-RBA_ID]);

          if ( ClassTmp == 1 ) LANaddrTmp = inet_addr("10.0.0.0");
          if ( ClassTmp == 2 ) LANaddrTmp = inet_addr("172.16.0.0");
          if ( ClassTmp == 3 ) LANaddrTmp = inet_addr("192.168.0.0");

          for (p = (unsigned char *)&LANaddrTmp, i=0; i<4; i++)
            {
            k = *(p+i);
            _itoa(k, &buf[0], 10);
            WinSetDlgItemText(hwnd, BYTE1_ID+i, buf);

            WinSendDlgItemMsg(hwnd,BYTE1_ID+i,EM_SETREADONLY,(MPARAM)TRUE,0);
            WinSetPresParam(WinWindowFromID(hwnd, BYTE1_ID+i),
                            PP_FOREGROUNDCOLORINDEX,
                            sizeof(ColorBlack), (PVOID)&ColorBlack);
            }

          if ( (ClassTmp == 2) || (ClassTmp == 3) )
            {
            WinSendDlgItemMsg(hwnd, BYTE1_ID+ClassTmp-1, EM_SETREADONLY,
                              (MPARAM)FALSE, 0);
            WinSetPresParam(WinWindowFromID(hwnd, BYTE1_ID+ClassTmp-1),
                            PP_FOREGROUNDCOLORINDEX,
                            sizeof(ColorRed), (PVOID)&ColorRed);
            }

          return (0);
          }
        }
      break;
      }
//-----------------------------------------------------------------------------
// Handle WM_COMMAND
//-----------------------------------------------------------------------------
    case WM_COMMAND:
      {
      switch(SHORT1FROMMP(mp1))
        {
        case DID_OK:
          {
          strcpy(IPaddr, "");
          for (i=0; i<4; i++)
            {
            WinQueryDlgItemText(hwnd, BYTE1_ID+i, 4, buf);
            strcat(IPaddr, buf);
            strcat(IPaddr, ".");
            }
          IPaddr[strlen(IPaddr)-1] = '\0';

          if ( (IP=inet_addr(IPaddr)) == INADDR_NONE )
            {
            WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, PgmMsg[0], ErrTitle, 0,
                          MB_OK|MB_SYSTEMMODAL|MB_ERROR);
            WinSetFocus(HWND_DESKTOP, WinWindowFromID(hwnd, BYTE1_ID));
            return(0);
            }

          p = (unsigned char *)&IP;
          if ( ClassTmp == 2 )
            if ( (*(p+1) > 31) || (*(p+1) < 16) )
              { //    B ytdthty
              WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, PgmMsg[1], ErrTitle, 0,
                            MB_OK|MB_SYSTEMMODAL|MB_ERROR);
              WinSetFocus(HWND_DESKTOP, WinWindowFromID(hwnd, BYTE1_ID));
              return(0);
              }

          IP &= MaskTmp;
          for (i=0; i<2; i++)
            if ( (i != ind) && (IP == HLANaddr[i]) )
              { // 㡫஢  
              WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, PgmMsg[2], ErrTitle, 0,
                            MB_OK|MB_SYSTEMMODAL|MB_ERROR);
              WinSetFocus(HWND_DESKTOP, WinWindowFromID(hwnd, BYTE1_ID));
              return(0);
              }

          tHLANaddr[ind] = IP;
          tHClass[ind] = ClassTmp;
          tHMask[ind] = MaskTmp;
          if ( !TestCfgIP1() )
            { // ஢ઠ  諠
            WinSetFocus(HWND_DESKTOP, WinWindowFromID(hwnd, BYTE1_ID));
            return(0);
            }

          HLANaddr[ind] = IP;
          HClass[ind] = ClassTmp;
          HMask[ind] = MaskTmp;

          break;
          }
        }
      }
      break;
    }
  return (WinDefDlgProc (hwnd,msg,mp1,mp2));
}

//=============================================================================
// SaveCfg - ணࠬ ࠭ 䨣樨
//=============================================================================
void SaveCfg(void)
{
  hini = PrfOpenProfile(hab, IniName); // Open private profile
  PrfWriteProfileData(hini, AppName, RLANname, &OLANaddr[0], sizeof(OLANaddr[0]));
  PrfWriteProfileData(hini, AppName, RMskName, &OMask[0], sizeof(OMask[0]));
  PrfWriteProfileData(hini, AppName, RClsName, &OClass[0], sizeof(OClass[0]));
  PrfWriteProfileData(hini, AppName, Rl0name,  &OIPaddrR, sizeof(OIPaddrR));
  PrfWriteProfileData(hini, AppName, PC1l0name, &OIPaddrPC1[0], sizeof(OIPaddrPC1[0]));
  PrfWriteProfileData(hini, AppName, PC2l0name, &OIPaddrPC2[0], sizeof(OIPaddrPC2[0]));
  PrfWriteProfileData(hini, AppName, VLAN1name, &OLANaddr[1], sizeof(OLANaddr[1]));
  PrfWriteProfileData(hini, AppName, VMsk1Name, &OMask[1], sizeof(OMask[1]));
  PrfWriteProfileData(hini, AppName, VCls1Name, &OClass[1], sizeof(OClass[1]));
  PrfWriteProfileData(hini, AppName, PC1l1name, &OIPaddrPC1[1], sizeof(OIPaddrPC1[1]));
  PrfWriteProfileData(hini, AppName, VM1l0name, &OIPaddrVM[0], sizeof(OIPaddrVM[0]));
  PrfWriteProfileData(hini, AppName, VM1OSname, &OOS[0], sizeof(OOS[0]));
  PrfWriteProfileData(hini, AppName, VM2l0name, &OIPaddrVM[1], sizeof(OIPaddrVM[1]));
  PrfWriteProfileData(hini, AppName, VM2OSname, &OOS[1], sizeof(OOS[1]));
  PrfWriteProfileData(hini, AppName, VLAN2name, &OLANaddr[2], sizeof(OLANaddr[2]));
  PrfWriteProfileData(hini, AppName, VMsk2Name, &OMask[2], sizeof(OMask[2]));
  PrfWriteProfileData(hini, AppName, VCls2Name, &OClass[2], sizeof(OClass[2]));
  PrfWriteProfileData(hini, AppName, PC2l1name, &OIPaddrPC2[1], sizeof(OIPaddrPC2[1]));
  PrfWriteProfileData(hini, AppName, VM3l0name, &OIPaddrVM[2], sizeof(OIPaddrVM[2]));
  PrfWriteProfileData(hini, AppName, VM3OSname, &OOS[3], sizeof(OOS[3]));

  PrfWriteProfileData(hini, AppName, RLANname1, &HLANaddr[0], sizeof(HLANaddr[0]));
  PrfWriteProfileData(hini, AppName, RMskName1, &HMask[0], sizeof(HMask[0]));
  PrfWriteProfileData(hini, AppName, RClsName1, &HClass[0], sizeof(HClass[0]));
  PrfWriteProfileData(hini, AppName, PCl0name1, &HIPaddrPC1[0], sizeof(HIPaddrPC1[0]));
  PrfWriteProfileData(hini, AppName, VLANname1, &HLANaddr[1], sizeof(HLANaddr[1]));
  PrfWriteProfileData(hini, AppName, VMskName1, &HMask[1], sizeof(HMask[1]));
  PrfWriteProfileData(hini, AppName, VClsName1, &HClass[1], sizeof(HClass[1]));
  PrfWriteProfileData(hini, AppName, PCl1name1, &HIPaddrPC1[1], sizeof(HIPaddrPC1[1]));
  PrfWriteProfileData(hini, AppName, VM1l0name1, &HIPaddrVM[0], sizeof(HIPaddrVM[0]));
  PrfWriteProfileData(hini, AppName, VM1OSname1, &HOS[0], sizeof(HOS[0]));
  PrfWriteProfileData(hini, AppName, VM2l0name1, &HIPaddrVM[1], sizeof(HIPaddrVM[1]));
  PrfWriteProfileData(hini, AppName, VM2OSname1, &HOS[1], sizeof(HOS[1]));

  PrfCloseProfile(hini);   // Close private profile
}

//=============================================================================
// LoadCfg - ணࠬ 㧪 䨣樨
//=============================================================================
BOOL LoadCfg(void)
{
  hini = PrfOpenProfile(hab, IniName); // Open private profile
  if ( !hini ) return(FALSE);

  GetParm(RLANname, OLANaddr[0]);
  GetParm(RMskName, OMask[0]);
  GetParm(RClsName, OClass[0]);
  GetParm(Rl0name,  OIPaddrR);
  GetParm(PC1l0name, OIPaddrPC1[0]);
  GetParm(PC2l0name, OIPaddrPC2[0]);
  GetParm(VLAN1name, OLANaddr[1]);
  GetParm(VMsk1Name, OMask[1]);
  GetParm(VCls1Name, OClass[1]);
  GetParm(PC1l1name, OIPaddrPC1[1]);
  GetParm(VM1l0name, OIPaddrVM[0]);
  GetParm(VM1OSname, OOS[0]);
  GetParm(VM2l0name, OIPaddrVM[1]);
  GetParm(VM2OSname, OOS[1]);
  GetParm(VLAN2name, OLANaddr[2]);
  GetParm(VMsk2Name, OMask[2]);
  GetParm(VCls2Name, OClass[2]);
  GetParm(PC2l1name, OIPaddrPC2[1]);
  GetParm(VM3l0name, OIPaddrVM[2]);
  GetParm(VM3OSname, OOS[3]);

  GetParm(RLANname1, HLANaddr[0]);
  GetParm(RMskName1, HMask[0]);
  GetParm(RClsName1, HClass[0]);
  GetParm(PCl0name1, HIPaddrPC1[0]);
  GetParm(VLANname1, HLANaddr[1]);
  GetParm(VMskName1, HMask[1]);
  GetParm(VClsName1, HClass[1]);
  GetParm(PCl1name1, HIPaddrPC1[1]);
  GetParm(VM1l0name1, HIPaddrVM[0]);
  GetParm(VM1OSname1, HOS[0]);
  GetParm(VM2l0name1, HIPaddrVM[1]);
  GetParm(VM2OSname1, HOS[1]);

  PrfCloseProfile(hini);   // Close private profile
  return(TRUE);
}

//=============================================================================
// FormCfg - ணࠬ ନ஢ 䨣樨
//=============================================================================
void FormCfg(void)
{
FILE *FileOut, *FileCmd;
char PathCmd[CCHMAXPATH];
u_long MyIPaddr[2], TempIPaddr;
int i;

  mkdir("Office");
  mkdir("Office\\Router");
  mkdir("Office\\PC1");
  mkdir("Office\\PC2");
  mkdir("Office\\VM1");
  mkdir("Office\\VM2");
  mkdir("Office\\VM3");

  FileOut=fopen("ConfigIP.htm", "w");

  fprintf(FileOut, "<!doctype html public \"-//w3c//dtd html 4.0 transitional//en\">\n");
  fprintf(FileOut, "<html>\n");
  fprintf(FileOut, "<head>\n");
  fprintf(FileOut, "<meta http-equiv=\"Content-Type\" content=\"text/html;charset=%s\">\n", CfgMsg[0]);
  fprintf(FileOut, "<title>%s</title>\n", CfgMsg[1]);
  fprintf(FileOut, "</head>\n");
  fprintf(FileOut, "<body text=\"#000000\" bgcolor=\"#c0c0c0\" link=\"#0000FF\" vlink=\"#000080\" alink=\"#FF0000\">\n");

  fprintf(FileOut, "<font color=\"#FF0000\">\n");
  fprintf(FileOut, "%s\n", CfgMsg[2]);
  fprintf(FileOut, "%s\n<br><br>\n", CfgMsg[3]);
  fprintf(FileOut, "%s\n", CfgMsg[4]);
  fprintf(FileOut, "%s\n", CfgMsg[5]);
  fprintf(FileOut, "</font>\n");

  fprintf(FileOut, "<hr style=\"width: 100%; height: 2px;\">\n");

// Router
  fprintf(FileOut, "<center><h3>Router</h3></center>\n");

  fprintf(FileOut, "<ul>\n");
  fprintf(FileOut, "<li>");
  fprintf(FileOut, CfgMsg[21], inet_ntoa(*(struct in_addr *)&OIPaddrR));
  fprintf(FileOut, CfgMsg[6], inet_ntoa(*(struct in_addr *)&OMask[0]));
  fprintf(FileOut, "<li>\n");
  fprintf(FileOut, CfgMsg[7], inet_ntoa(*(struct in_addr *)&OLANaddr[1]));
  fprintf(FileOut, " %s (%s%d)", inet_ntoa(*(struct in_addr *)&OIPaddrPC1[0]), CfgMsg[42], 1);
  fprintf(FileOut, "</li>\n");
  fprintf(FileOut, "<li>");
  fprintf(FileOut, CfgMsg[7], inet_ntoa(*(struct in_addr *)&OLANaddr[2]));
  fprintf(FileOut, " %s (%s%d)", inet_ntoa(*(struct in_addr *)&OIPaddrPC2[0]), CfgMsg[42], 2);
  fprintf(FileOut, "</li>\n");
  fprintf(FileOut, "</ul>\n");

  fprintf(FileOut, CfgMsg[24], CfgMsg[31], '\n');
  fprintf(FileOut, " %s\n", CfgMsg[9]);
  fprintf(FileOut, "%s\n", CfgMsg[10]);

  fprintf(FileOut, "<center><h4>setup.cmd</h4></center>\n");
  fprintf(FileOut, "<dl>\n");
  fprintf(FileOut, "<dt><font color=\"#FF0000\">");
  fprintf(FileOut, CfgMsg[11], CfgMsg[12]);
  fprintf(FileOut, "</font></dt>\n");
  fprintf(FileOut, "<dt>route -fh</dt>\n");
  fprintf(FileOut, "<dt><font color=\"#FF0000\">");
  fprintf(FileOut, CfgMsg[11], CfgMsg[13]);
  fprintf(FileOut, "</font></dt>\n");
  fprintf(FileOut, "<dt>arp -f</dt>\n");
  fprintf(FileOut, "<dt><font color=\"#FF0000\">");
  fprintf(FileOut, "%s\n", CfgMsg[14]);
  fprintf(FileOut, "</font></dt>\n");
  fprintf(FileOut, "<dt>ifconfig lo 127.0.0.1</dt>\n");
  fprintf(FileOut, "<dt><font color=\"#FF0000\">");
  fprintf(FileOut, CfgMsg[15], 0);
  fprintf(FileOut, "</font></dt>\n");
  fprintf(FileOut, "<dt>ifconfig lan0 %s ", inet_ntoa(*(struct in_addr *)&OIPaddrR) );
  fprintf(FileOut, "netmask %s metric 1 mtu 1500</dt>\n", inet_ntoa(*(struct in_addr *)&OMask[0]));
  fprintf(FileOut, "<dt><font color=\"#FF0000\">");
  fprintf(FileOut, CfgMsg[16], inet_ntoa(*(struct in_addr *)&OLANaddr[1]), CfgMsg[42], 1);
  fprintf(FileOut, "</font></dt>\n");
  fprintf(FileOut, "<dt>route add %s ", inet_ntoa(*(struct in_addr *)&OLANaddr[1]));
  fprintf(FileOut, "%s</dt>\n", inet_ntoa(*(struct in_addr *)&OIPaddrPC1[0]));
  fprintf(FileOut, "<dt><font color=\"#FF0000\">");
  fprintf(FileOut, CfgMsg[16], inet_ntoa(*(struct in_addr *)&OLANaddr[2]), CfgMsg[42], 2);
  fprintf(FileOut, "</font></dt>\n");
  fprintf(FileOut, "<dt>route add %s ", inet_ntoa(*(struct in_addr *)&OLANaddr[2]));
  fprintf(FileOut, "%s</dt>\n", inet_ntoa(*(struct in_addr *)&OIPaddrPC2[0]));
  fprintf(FileOut, "<dt><font color=\"#FF0000\">%s</font></dt>\n", CfgMsg[17]);
  fprintf(FileOut, "<dt>ipgate on</dt>\n");
  fprintf(FileOut, "</dl>\n");

  FileCmd=fopen("Office\\Router\\setup.cmd", "w");
  fprintf(FileCmd, "route -fh\n");
  fprintf(FileCmd, "arp -f\n");
  fprintf(FileCmd, "ifconfig lo 127.0.0.1\n");
  fprintf(FileCmd, "ifconfig lan0 %s ", inet_ntoa(*(struct in_addr *)&OIPaddrR) );
  fprintf(FileCmd, "netmask %s metric 1 mtu 1500\n", inet_ntoa(*(struct in_addr *)&OMask[0]));
  fprintf(FileCmd, "route add %s ", inet_ntoa(*(struct in_addr *)&OLANaddr[1]));
  fprintf(FileCmd, "%s\n", inet_ntoa(*(struct in_addr *)&OIPaddrPC1[0]));
  fprintf(FileCmd, "route add %s ", inet_ntoa(*(struct in_addr *)&OLANaddr[2]));
  fprintf(FileCmd, "%s\n", inet_ntoa(*(struct in_addr *)&OIPaddrPC2[0]));
  fprintf(FileCmd, "ipgate on\n");
  fclose(FileCmd);

  fprintf(FileOut, "%s\n", CfgMsg[18]);
  fprintf(FileOut, "%s\n", CfgMsg[19]);
  fprintf(FileOut, "<br>\n");
  fprintf(FileOut, "<font color=\"#0000FF\">nameserver 153.11.7.31</font>\n");
  fprintf(FileOut, "<br>\n");
  fprintf(FileOut, "%s\n", CfgMsg[20]);

// PC
  for (i=1; i<3; i++)
    {
    if ( i == 1 )
      {
      memcpy(MyIPaddr, OIPaddrPC1, sizeof(OIPaddrPC1));
      TempIPaddr = OIPaddrPC2[0];
      }
    else
      {
      memcpy(MyIPaddr, OIPaddrPC2, sizeof(OIPaddrPC2));
      TempIPaddr = OIPaddrPC1[0];
      }

    fprintf(FileOut, "<hr style=\"width: 100%; height: 2px;\">\n");
    fprintf(FileOut, "<center><h3>%s%d</h3></center>\n", CfgMsg[42], i);

    fprintf(FileOut, "<ul>\n");
    fprintf(FileOut, "<li>");
    fprintf(FileOut, CfgMsg[21], inet_ntoa(*(struct in_addr *)&MyIPaddr[0]));
    fprintf(FileOut, CfgMsg[6], inet_ntoa(*(struct in_addr *)&OMask[0]));
    fprintf(FileOut, "</li>\n");
    fprintf(FileOut, "<li>");
    fprintf(FileOut, CfgMsg[22], 1, inet_ntoa(*(struct in_addr *)&MyIPaddr[1]));
    fprintf(FileOut, CfgMsg[6], inet_ntoa(*(struct in_addr *)&OMask[i]));
    fprintf(FileOut, "</li>\n");
    fprintf(FileOut, "<li>");
    fprintf(FileOut, CfgMsg[7], inet_ntoa(*(struct in_addr *)&OLANaddr[i%2+1]));
    fprintf(FileOut, " %s (%s%d)", inet_ntoa(*(struct in_addr *)&TempIPaddr), CfgMsg[42], i%2+1);
    fprintf(FileOut, "</li>\n");
    fprintf(FileOut, "<li>");
    fprintf(FileOut, CfgMsg[23], inet_ntoa(*(struct in_addr *)&OIPaddrR), "Router");
    fprintf(FileOut, "</li>\n");
    fprintf(FileOut, "</ul>\n");

    fprintf(FileOut, CfgMsg[24], OStxt[0]);
    fprintf(FileOut, " %s\n", CfgMsg[25]);
    fprintf(FileOut, "%s\n", CfgMsg[10]);

    fprintf(FileOut, "<center><h4>setup.cmd</h4></center>\n");
    fprintf(FileOut, "<dl>\n");
    fprintf(FileOut, "<dt><font color=\"#FF0000\">");
    fprintf(FileOut, CfgMsg[11], CfgMsg[12]);
    fprintf(FileOut, "</font></dt>\n");
    fprintf(FileOut, "<dt>route -fh</dt>\n");
    fprintf(FileOut, "<dt><font color=\"#FF0000\">");
    fprintf(FileOut, CfgMsg[11], CfgMsg[13]);
    fprintf(FileOut, "</font></dt>\n");
    fprintf(FileOut, "<dt>arp -f</dt>\n");
    fprintf(FileOut, "<dt><font color=\"#FF0000\">");
    fprintf(FileOut, "%s\n", CfgMsg[14]);
    fprintf(FileOut, "</font></dt>\n");
    fprintf(FileOut, "<dt>ifconfig lo 127.0.0.1</dt>\n");
    fprintf(FileOut, "<dt><font color=\"#FF0000\">");
    fprintf(FileOut, CfgMsg[15], 0);
    fprintf(FileOut, "</font></dt>\n");
    fprintf(FileOut, "<dt>ifconfig lan0 %s ", inet_ntoa(*(struct in_addr *)&MyIPaddr[0]));
    fprintf(FileOut, "netmask %s metric 1 mtu 1500</dt>\n", inet_ntoa(*(struct in_addr *)&OMask[0]));
    fprintf(FileOut, "<dt><font color=\"#FF0000\">");
    fprintf(FileOut, CfgMsg[15], 1);
    fprintf(FileOut, "</font></dt>\n");
    fprintf(FileOut, "<dt>ifconfig lan1 %s ", inet_ntoa(*(struct in_addr *)&MyIPaddr[1]) );
    fprintf(FileOut, "netmask %s metric 1 mtu 1500</dt>\n", inet_ntoa(*(struct in_addr *)&OMask[i]));
    fprintf(FileOut, "<dt><font color=\"#FF0000\">");
    fprintf(FileOut, CfgMsg[46], "Router");
    fprintf(FileOut, "</font></dt>\n");
    fprintf(FileOut, "<dt>route add default %s</dt>\n", inet_ntoa(*(struct in_addr *)&OIPaddrR));
    fprintf(FileOut, "<dt><font color=\"#FF0000\">");
    fprintf(FileOut, CfgMsg[16], inet_ntoa(*(struct in_addr *)&OLANaddr[i%2+1]), CfgMsg[42], i%2+1);
    fprintf(FileOut, "</font></dt>\n");
    fprintf(FileOut, "<dt>route add %s ", inet_ntoa(*(struct in_addr *)&OLANaddr[i%2+1]) );
    fprintf(FileOut, "%s</dt>\n", inet_ntoa(*(struct in_addr *)&TempIPaddr) );
    fprintf(FileOut, "<dt><font color=\"#FF0000\">%s</font></dt>\n", CfgMsg[17]);
    fprintf(FileOut, "<dt>ipgate on</dt>\n");
    fprintf(FileOut, "</dl>\n");

    sprintf(PathCmd, "Office\\PC%d\\setup.cmd", i);
    FileCmd=fopen(PathCmd, "w");
    fprintf(FileCmd, "route -fh\n");
    fprintf(FileCmd, "arp -f\n");
    fprintf(FileCmd, "ifconfig lo 127.0.0.1\n");
    fprintf(FileCmd, "ifconfig lan0 %s ", inet_ntoa(*(struct in_addr *)&MyIPaddr[0]));
    fprintf(FileCmd, "netmask %s metric 1 mtu 1500\n", inet_ntoa(*(struct in_addr *)&OMask[0]));
    fprintf(FileCmd, "ifconfig lan1 %s ", inet_ntoa(*(struct in_addr *)&MyIPaddr[1]) );
    fprintf(FileCmd, "netmask %s metric 1 mtu 1500\n", inet_ntoa(*(struct in_addr *)&OMask[i]));
    fprintf(FileCmd, "route add default %s\n", inet_ntoa(*(struct in_addr *)&OIPaddrR));
    fprintf(FileCmd, "route add %s ", inet_ntoa(*(struct in_addr *)&OLANaddr[i%2+1]) );
    fprintf(FileCmd, "%s\n", inet_ntoa(*(struct in_addr *)&TempIPaddr) );
    fprintf(FileCmd, "ipgate on\n");
    fclose(FileCmd);

    fprintf(FileOut, "%s\n", CfgMsg[18]);
    fprintf(FileOut, "%s\n", CfgMsg[19]);
    fprintf(FileOut, "<br>\n");
    fprintf(FileOut, "<font color=\"#0000FF\">nameserver 153.11.7.31</font>\n");
    fprintf(FileOut, "<br>\n");
    fprintf(FileOut, "%s\n", CfgMsg[20]);
    }

// VM
  for (i=0; i<3; i++)
    {
    u_long MyIPaddr[2], OthIPaddr;

    if ( i < 2 ) TempIPaddr = OIPaddrPC1[1];
    else TempIPaddr = OIPaddrPC2[1];

    fprintf(FileOut, "<hr style=\"width: 100%; height: 2px;\">\n");
    fprintf(FileOut, "<center><h3>%s%d</h3></center>\n", CfgMsg[43], i+1);

    fprintf(FileOut, "<ul>\n");
    fprintf(FileOut, "<li>");
    fprintf(FileOut, CfgMsg[22], 0, inet_ntoa(*(struct in_addr *)&OIPaddrVM[i]));
    fprintf(FileOut, CfgMsg[6], inet_ntoa(*(struct in_addr *)&OMask[i/2+1]));
    fprintf(FileOut, "</li>\n");
    fprintf(FileOut, "<li>");
    fprintf(FileOut, CfgMsg[44], inet_ntoa(*(struct in_addr *)&TempIPaddr), CfgMsg[42], i/2+1);
    fprintf(FileOut, "</li>\n");
    fprintf(FileOut, "<li>%s", CfgMsg[26]);
    fprintf(FileOut, " %s</li>\n</ul>\n", OStxt[OOS[i]]);

    fprintf(FileOut, CfgMsg[24], OStxt[OOS[i]], '\n');

    if ( OOS[i] == 0 )
      { // eCS
      fprintf(FileOut, " %s\n", CfgMsg[25]);
      fprintf(FileOut, "%s\n", CfgMsg[10]);

      fprintf(FileOut, "<center><h4>setup.cmd</h4></center>\n");
      fprintf(FileOut, "<dl>\n");
      fprintf(FileOut, "<dt><font color=\"#FF0000\">");
      fprintf(FileOut, CfgMsg[11], CfgMsg[12]);
      fprintf(FileOut, "</font></dt>\n");
      fprintf(FileOut, "<dt>route -fh</dt>\n");
      fprintf(FileOut, "<dt><font color=\"#FF0000\">");
      fprintf(FileOut, CfgMsg[11], CfgMsg[13]);
      fprintf(FileOut, "</font></dt>\n");
      fprintf(FileOut, "<dt>arp -f</dt>\n");
      fprintf(FileOut, "<dt><font color=\"#FF0000\">%s</font></dt>\n", CfgMsg[14]);
      fprintf(FileOut, "<dt>ifconfig lo 127.0.0.1</dt>\n");
      fprintf(FileOut, "<dt><font color=\"#FF0000\">");
      fprintf(FileOut, CfgMsg[15], 0);
      fprintf(FileOut, "</font></dt>\n");
      fprintf(FileOut, "<dt>ifconfig lan0 %s ", inet_ntoa(*(struct in_addr *)&OIPaddrVM[i]));
      fprintf(FileOut, "netmask %s</dt>\n", inet_ntoa(*(struct in_addr *)&OMask[i/2+1]));
      fprintf(FileOut, "<dt><font color=\"#FF0000\">");
      fprintf(FileOut, CfgMsg[45], CfgMsg[42], i/2+1);
      fprintf(FileOut, "</font></dt>\n");
      fprintf(FileOut, "<dt>route add default %s</dt>\n", inet_ntoa(*(struct in_addr *)&TempIPaddr));
      fprintf(FileOut, "</dl>\n");

      sprintf(PathCmd, "Office\\VM%d\\setup.cmd", i+1);
      FileCmd=fopen(PathCmd, "w");
      fprintf(FileCmd, "route -fh\n");
      fprintf(FileCmd, "arp -f\n");
      fprintf(FileCmd, "ifconfig lo 127.0.0.1\n");
      fprintf(FileCmd, "ifconfig lan0 %s ", inet_ntoa(*(struct in_addr *)&OIPaddrVM[i]));
      fprintf(FileCmd, "netmask %s\n", inet_ntoa(*(struct in_addr *)&OMask[i/2+1]));
      fprintf(FileCmd, "route add default %s\n", inet_ntoa(*(struct in_addr *)&TempIPaddr));
      fclose(FileCmd);

      fprintf(FileOut, "%s\n", CfgMsg[18]);
      fprintf(FileOut, "%s\n", CfgMsg[19]);
      fprintf(FileOut, "<br>\n");
      fprintf(FileOut, "<font color=\"#0000FF\">nameserver 153.11.7.31</font>\n");
      fprintf(FileOut, "<br>\n");
      fprintf(FileOut, "%s\n", CfgMsg[20]);
      }
    else
      if ( OOS[i] == 1 ) // Linux
        fprintf(FileOut, " %s\n", CfgMsg[27]);
      else
        { // Windows
        fprintf(FileOut, "<br>%s\n", CfgMsg[28]);
        fprintf(FileOut, "%s\n", CfgMsg[29]);
        fprintf(FileOut, "%s\n", CfgMsg[30]);
        }
    }

  fprintf(FileOut, "</body>\n</html>\n");
  fclose(FileOut);
}

//=============================================================================
// FormCfg1 - ணࠬ ନ஢ 䨣樨
//=============================================================================
void FormCfg1(void)
{
FILE *FileOut, *FileCmd;
int i;
char PathCmd[CCHMAXPATH];
char *NatTxt[] = { "NAT (InJoy Dialer)",
                   "Proxy server (SQUID)",
                   "Socks server (SOCKSD)" };

  mkdir("Home");
  mkdir("Home\\PC");
  mkdir("Home\\VM1");
  mkdir("Home\\VM2");

  FileOut=fopen("ConfigIP.htm", "w");

  fprintf(FileOut, "<!doctype html public \"-//w3c//dtd html 4.0 transitional//en\">\n");
  fprintf(FileOut, "<html>\n");
  fprintf(FileOut, "<head>\n");
  fprintf(FileOut, "<meta http-equiv=\"Content-Type\" content=\"text/html;charset=%s\">\n", CfgMsg[0]);
  fprintf(FileOut, "<title>%s</title>\n", CfgMsg[1]);
  fprintf(FileOut, "</head>\n");
  fprintf(FileOut, "<body text=\"#000000\" bgcolor=\"#c0c0c0\" link=\"#0000FF\" vlink=\"#000080\" alink=\"#FF0000\">\n");

  fprintf(FileOut, "<font color=\"#FF0000\">\n");
  fprintf(FileOut, "%s\n", CfgMsg[2]);
  fprintf(FileOut, "%s\n<br><br>\n", CfgMsg[3]);
  fprintf(FileOut, "%s\n", CfgMsg[4]);
  fprintf(FileOut, "%s\n", CfgMsg[5]);
  fprintf(FileOut, "</font>\n");

// PC
  fprintf(FileOut, "<hr style=\"width: 100%; height: 2px;\">\n");
  fprintf(FileOut, "<center><h3>%s</h3></center>\n", CfgMsg[42]);

  fprintf(FileOut, "<ul>\n");
  fprintf(FileOut, "<li>");
  fprintf(FileOut, CfgMsg[21], inet_ntoa(*(struct in_addr *)&HIPaddrPC1[0]));
  fprintf(FileOut, CfgMsg[6], inet_ntoa(*(struct in_addr *)&HMask[0]));
  fprintf(FileOut, "</li>\n");
  fprintf(FileOut, "<li>");
  fprintf(FileOut, CfgMsg[22], 1, inet_ntoa(*(struct in_addr *)&HIPaddrPC1[1]));
  fprintf(FileOut, CfgMsg[6], inet_ntoa(*(struct in_addr *)&HMask[1]));
  fprintf(FileOut, "</li>\n");
  fprintf(FileOut, "<li>%s %s</li>\n", CfgMsg[40], NatTxt[Nat-1]);
  fprintf(FileOut, "</ul>\n");

  fprintf(FileOut, CfgMsg[24], OStxt[0]);
  fprintf(FileOut, " %s\n", CfgMsg[25]);
  fprintf(FileOut, "%s\n", CfgMsg[10]);

  fprintf(FileOut, "<center><h4>setup.cmd</h4></center>\n");
  fprintf(FileOut, "<dl>\n");
  fprintf(FileOut, "<dt><font color=\"#FF0000\">");
  fprintf(FileOut, CfgMsg[11], CfgMsg[12]);
  fprintf(FileOut, "</font></dt>\n");
  fprintf(FileOut, "<dt>route -fh</dt>\n");
  fprintf(FileOut, "<dt><font color=\"#FF0000\">");
  fprintf(FileOut, CfgMsg[11], CfgMsg[13]);
  fprintf(FileOut, "</font></dt>\n");
  fprintf(FileOut, "<dt>arp -f</dt>\n");
  fprintf(FileOut, "<dt><font color=\"#FF0000\">");
  fprintf(FileOut, "%s\n", CfgMsg[14]);
  fprintf(FileOut, "</font></dt>\n");
  fprintf(FileOut, "<dt>ifconfig lo 127.0.0.1</dt>\n");
  fprintf(FileOut, "<dt><font color=\"#FF0000\">");
  fprintf(FileOut, CfgMsg[15], 0);
  fprintf(FileOut, "</font></dt>\n");
  fprintf(FileOut, "<dt>ifconfig lan0 %s ", inet_ntoa(*(struct in_addr *)&HIPaddrPC1[0]));
  fprintf(FileOut, "netmask %s metric 1 mtu 1500</dt>\n", inet_ntoa(*(struct in_addr *)&HMask[0]));
  fprintf(FileOut, "<dt><font color=\"#FF0000\">");
  fprintf(FileOut, CfgMsg[15], 1);
  fprintf(FileOut, "</font></dt>\n");
  fprintf(FileOut, "<dt>ifconfig lan1 %s ", inet_ntoa(*(struct in_addr *)&HIPaddrPC1[1]) );
  fprintf(FileOut, "netmask %s metric 1 mtu 1500</dt>\n", inet_ntoa(*(struct in_addr *)&HMask[1]));
  fprintf(FileOut, "<dt><font color=\"#FF0000\">%s</font></dt>\n", CfgMsg[17]);
  fprintf(FileOut, "<dt>ipgate on</dt>\n");
  fprintf(FileOut, "</dl>\n");

  FileCmd=fopen("Home\\PC\\setup.cmd", "w");
  fprintf(FileCmd, "route -fh\n");
  fprintf(FileCmd, "arp -f\n");
  fprintf(FileCmd, "ifconfig lo 127.0.0.1\n");
  fprintf(FileCmd, "ifconfig lan0 %s ", inet_ntoa(*(struct in_addr *)&HIPaddrPC1[0]));
  fprintf(FileCmd, "netmask %s metric 1 mtu 1500\n", inet_ntoa(*(struct in_addr *)&HMask[0]));
  fprintf(FileCmd, "ifconfig lan1 %s ", inet_ntoa(*(struct in_addr *)&HIPaddrPC1[1]) );
  fprintf(FileCmd, "netmask %s metric 1 mtu 1500\n", inet_ntoa(*(struct in_addr *)&HMask[1]));
  fprintf(FileCmd, "ipgate on\n");
  fclose(FileCmd);

  fprintf(FileOut, "%s\n", CfgMsg[18]);
  fprintf(FileOut, "%s\n", CfgMsg[19]);
  fprintf(FileOut, "<br>\n");
  fprintf(FileOut, "<font color=\"#0000FF\">nameserver 153.11.7.31</font>\n");
  fprintf(FileOut, "<br>\n");
  fprintf(FileOut, "%s\n", CfgMsg[20]);

  if ( Nat == 1 ) // NAT
    {
    fprintf(FileOut, "<center><h4>%s</h4></center>\n", CfgMsg[41]);
    fprintf(FileOut, "<img src=\"InJoy01.gif\">\n<br><br>\n");
    fprintf(FileOut, "<img src=\"InJoy02.gif\">\n");
    }
  else
    if ( Nat == 2 ) // proxy
      {
      fprintf(FileOut, "<center><h4>squid.conf</h4></center>\n");
      fprintf(FileOut, "<dl>\n");
      fprintf(FileOut, "<dt><font color=\"#FF0000\">%s</font></dt>\n", CfgMsg[56]);
      fprintf(FileOut, "<dt>http_port 3128</dt>\n");
      fprintf(FileOut, "<dt><font color=\"#FF0000\">%s</font></dt>\n", CfgMsg[57]);
      fprintf(FileOut, "<dt>cache_dir ufs cache 100 16 256</dt>\n");
      fprintf(FileOut, "<dt><font color=\"#FF0000\">%s</font></dt>\n", CfgMsg[58]);
      fprintf(FileOut, "<dt>cache_log cache.log</dt>\n");
      fprintf(FileOut, "<dt><font color=\"#FF0000\">%s</font></dt>\n", CfgMsg[59]);
      fprintf(FileOut, "<dt>acl all src 0.0.0.0/0.0.0.0</dt>\n");
      fprintf(FileOut, "<dt><font color=\"#FF0000\">%s</font></dt>\n", CfgMsg[60]);
      fprintf(FileOut, "<dt>acl my_networks src 127.0.0.1/255.255.255.255 %s/", inet_ntoa(*(struct in_addr *)&HLANaddr[0]));
      fprintf(FileOut, "%s ", inet_ntoa(*(struct in_addr *)&HMask[0]));
      fprintf(FileOut, "%s/", inet_ntoa(*(struct in_addr *)&HLANaddr[1]));
      fprintf(FileOut, "%s</dt>\n", inet_ntoa(*(struct in_addr *)&HMask[1]));
      fprintf(FileOut, "<dt><font color=\"#FF0000\">%s</font></dt>\n", CfgMsg[61]);
      fprintf(FileOut, "<dt>http_access allow my_networks</dt>\n");
      fprintf(FileOut, "<dt><font color=\"#FF0000\">%s</font></dt>\n", CfgMsg[62]);
      fprintf(FileOut, "<dt>http_access deny all</dt>\n");
      fprintf(FileOut, "<dt><font color=\"#FF0000\">%s</font></dt>\n", CfgMsg[63]);
      fprintf(FileOut, "<dt>http_reply_access allow all</dt>\n");
      fprintf(FileOut, "<dt><font color=\"#FF0000\">%s</font></dt>\n", CfgMsg[64]);
      fprintf(FileOut, "<dt>icp_port 0</dt>\n");
      fprintf(FileOut, "<dt><font color=\"#FF0000\">%s</font></dt>\n", CfgMsg[65]);
      fprintf(FileOut, "<dt>visible_hostname Your_PC_Hostname</dt>\n");
      fprintf(FileOut, "</dl>\n");
      fprintf(FileOut, "%s\n", CfgMsg[66]);

      FileCmd=fopen("Home\\PC\\squid.conf", "w");
      fprintf(FileCmd, "http_port 3128\n");
      fprintf(FileCmd, "cache_dir ufs cache 100 16 256\n");
      fprintf(FileCmd, "cache_log cache.log\n");
      fprintf(FileCmd, "acl all src 0.0.0.0/0.0.0.0\n");
      fprintf(FileCmd, "acl my_networks src 127.0.0.1/255.255.255.255 %s/", inet_ntoa(*(struct in_addr *)&HLANaddr[0]));
      fprintf(FileCmd, "%s ", inet_ntoa(*(struct in_addr *)&HMask[0]));
      fprintf(FileCmd, "%s/", inet_ntoa(*(struct in_addr *)&HLANaddr[1]));
      fprintf(FileCmd, "%s\n", inet_ntoa(*(struct in_addr *)&HMask[1]));
      fprintf(FileCmd, "http_access allow my_networks\n");
      fprintf(FileCmd, "http_access deny all\n");
      fprintf(FileCmd, "http_reply_access allow all\n");
      fprintf(FileCmd, "icp_port 0\n");
      fprintf(FileCmd, "visible_hostname Your_PC_Hostname\n");
      fclose(FileCmd);
      }
    else // socks
      {
      fprintf(FileOut, "<center><h4>socksd.cfg</h4></center>\n");
      fprintf(FileOut, "<dl>\n");
      fprintf(FileOut, "<dt><font color=\"#FF0000\">%s</font></dt>\n", CfgMsg[47]);
      fprintf(FileOut, "<dt>[Global]</dt>");
      fprintf(FileOut, "<dt><font color=\"#FF0000\">%s</font></dt>\n", CfgMsg[48]);
      fprintf(FileOut, "<dt>LogFile socks.log</dt>");
      fprintf(FileOut, "<dt><font color=\"#FF0000\">%s</font></dt>\n", CfgMsg[49]);
      fprintf(FileOut, "<dt>UserLog users.log</dt>");
      fprintf(FileOut, "<dt><font color=\"#FF0000\">%s</font></dt>\n", CfgMsg[50]);
      fprintf(FileOut, "<dt>MaxUsers 50</dt><p>");
      fprintf(FileOut, "<dt><font color=\"#FF0000\">%s</font></dt>\n", CfgMsg[51]);
      fprintf(FileOut, "<dt>[Socks:default]</dt>");
      fprintf(FileOut, "<dt><font color=\"#FF0000\">%s</font></dt>\n", CfgMsg[52]);
      fprintf(FileOut, "<dt>bind 1080</dt><p>");
      fprintf(FileOut, "<dt><font color=\"#FF0000\">%s</font></dt>\n", CfgMsg[53]);
      fprintf(FileOut, "<dt>[User:default]</dt>");
      fprintf(FileOut, "<dt><font color=\"#FF0000\">%s</font></dt>\n", CfgMsg[54]);
      fprintf(FileOut, "<dt>ip 127.0.0.1 %s/", inet_ntoa(*(struct in_addr *)&HLANaddr[0]));
      fprintf(FileOut, "%s ", inet_ntoa(*(struct in_addr *)&HMask[0]));
      fprintf(FileOut, "%s/", inet_ntoa(*(struct in_addr *)&HLANaddr[1]));
      fprintf(FileOut, "%s</dt>\n", inet_ntoa(*(struct in_addr *)&HMask[1]));
      fprintf(FileOut, "<dt><font color=\"#FF0000\">%s</font></dt>\n", CfgMsg[55]);
      fprintf(FileOut, "<dt>defrule allow</dt><p>\n");
      fprintf(FileOut, "<dt><font color=\"#FF0000\">%s</font></dt>\n", CfgMsg[67]);
      fprintf(FileOut, "<dt><font color=\"#FF0000\">%s</font></dt>\n", CfgMsg[68]);
      fprintf(FileOut, "<dt>[TcpMap:1]</dt>\n");
      fprintf(FileOut, "<dt>Bind 53</dt>");
      fprintf(FileOut, "<dt>[User:1]</dt>\n");
      fprintf(FileOut, "<dt>ip *</dt>\n");
      fprintf(FileOut, "<dt>Dest Ips [%s]:53</dt><p>\n", CfgMsg[71]);
      fprintf(FileOut, "<dt><font color=\"#FF0000\">%s</font></dt>\n", CfgMsg[69]);
      fprintf(FileOut, "<dt><font color=\"#FF0000\">%s</font></dt>\n", CfgMsg[70]);
      fprintf(FileOut, "<dt>[UdpMap:2]</dt>\n");
      fprintf(FileOut, "<dt>Bind 53</dt>\n");
      fprintf(FileOut, "<dt>[User:2]</dt>\n");
      fprintf(FileOut, "<dt>ip *</dt>\n");
      fprintf(FileOut, "<dt>Dest Ips [%s]:53</dt>\n", CfgMsg[71]);
      fprintf(FileOut, "</dl>\n");

      FileCmd=fopen("Home\\PC\\socksd.cfg", "w");
      fprintf(FileCmd, "[Global]\n");
      fprintf(FileCmd, "LogFile socks.log\n");
      fprintf(FileCmd, "UserLog users.log\n");
      fprintf(FileCmd, "MaxUsers 50\n\n");
      fprintf(FileCmd, "[Socks:default]\n");
      fprintf(FileCmd, "bind 1080\n\n");
      fprintf(FileCmd, "[User:default]\n");
      fprintf(FileCmd, "ip 127.0.0.1 %s/", inet_ntoa(*(struct in_addr *)&HLANaddr[0]));
      fprintf(FileCmd, "%s ", inet_ntoa(*(struct in_addr *)&HMask[0]));
      fprintf(FileCmd, "%s/", inet_ntoa(*(struct in_addr *)&HLANaddr[1]));
      fprintf(FileCmd, "%s\n", inet_ntoa(*(struct in_addr *)&HMask[1]));
      fprintf(FileCmd, "defrule allow\n\n");
      fprintf(FileCmd, "[TcpMap:1]\n");
      fprintf(FileCmd, "Bind 53\n");
      fprintf(FileCmd, "[User:1]\n");
      fprintf(FileCmd, "ip *\n");
      fprintf(FileCmd, "Dest Ips [%s]:53\n\n", CfgMsg[71]);
      fprintf(FileCmd, "[UdpMap:2]\n");
      fprintf(FileCmd, "Bind 53\n");
      fprintf(FileCmd, "[User:2]\n");
      fprintf(FileCmd, "ip *\n");
      fprintf(FileCmd, "Dest Ips [%s]:53\n", CfgMsg[71]);
      fclose(FileCmd);
      }

// VM
  for (i=0; i<2; i++)
    {
    u_long MyIPaddr[2], OthIPaddr;

    fprintf(FileOut, "<hr style=\"width: 100%; height: 2px;\">\n");
    fprintf(FileOut, "<center><h3>%s%d</h3></center>\n", CfgMsg[43], i+1);

    fprintf(FileOut, "<ul>\n");
    fprintf(FileOut, "<li>");
    fprintf(FileOut, CfgMsg[22], 0, inet_ntoa(*(struct in_addr *)&HIPaddrVM[i]));
    fprintf(FileOut, CfgMsg[6], inet_ntoa(*(struct in_addr *)&HMask[1]));
    fprintf(FileOut, "</li>\n");
    fprintf(FileOut, "<li>");
    fprintf(FileOut, CfgMsg[23], inet_ntoa(*(struct in_addr *)&HIPaddrPC1[1]), CfgMsg[42]);
    fprintf(FileOut, "</li>\n");
    fprintf(FileOut, "<li>%s", CfgMsg[26]);
    fprintf(FileOut, " %s</li>\n</ul>\n", OStxt[HOS[i]]);
    fprintf(FileOut, CfgMsg[24], OStxt[HOS[i]], '\n');

    if ( HOS[i] == 0 )
      { // eCS
      fprintf(FileOut, " %s\n", CfgMsg[25]);
      fprintf(FileOut, "%s\n", CfgMsg[10]);

      fprintf(FileOut, "<center><h4>setup.cmd</h4></center>\n");
      fprintf(FileOut, "<dl>\n");
      fprintf(FileOut, "<dt><font color=\"#FF0000\">");
      fprintf(FileOut, CfgMsg[11], CfgMsg[12]);
      fprintf(FileOut, "</font></dt>\n");
      fprintf(FileOut, "<dt>route -fh</dt>\n");
      fprintf(FileOut, "<dt><font color=\"#FF0000\">");
      fprintf(FileOut, CfgMsg[11], CfgMsg[13]);
      fprintf(FileOut, "</font></dt>\n");
      fprintf(FileOut, "<dt>arp -f</dt>\n");
      fprintf(FileOut, "<dt><font color=\"#FF0000\">%s</font></dt>\n", CfgMsg[14]);
      fprintf(FileOut, "<dt>ifconfig lo 127.0.0.1</dt>\n");
      fprintf(FileOut, "<dt><font color=\"#FF0000\">");
      fprintf(FileOut, CfgMsg[15], 0);
      fprintf(FileOut, "</font></dt>\n");
      fprintf(FileOut, "<dt>ifconfig lan0 %s ", inet_ntoa(*(struct in_addr *)&HIPaddrVM[i]));
      fprintf(FileOut, "netmask %s</dt>\n", inet_ntoa(*(struct in_addr *)&HMask[i/2+1]));
      fprintf(FileOut, "<dt><font color=\"#FF0000\">");
      fprintf(FileOut, CfgMsg[46], CfgMsg[42]);
      fprintf(FileOut, "</font></dt>\n");
      fprintf(FileOut, "<dt>route add default %s</dt>\n", inet_ntoa(*(struct in_addr *)&HIPaddrPC1[1]));
      fprintf(FileOut, "</dl>\n");

      sprintf(PathCmd, "Home\\VM%d\\setup.cmd", i+1);
      FileCmd=fopen(PathCmd, "w");
      fprintf(FileCmd, "route -fh\n");
      fprintf(FileCmd, "arp -f\n");
      fprintf(FileCmd, "ifconfig lo 127.0.0.1\n");
      fprintf(FileCmd, "ifconfig lan0 %s ", inet_ntoa(*(struct in_addr *)&HIPaddrVM[i]));
      fprintf(FileCmd, "netmask %s\n", inet_ntoa(*(struct in_addr *)&HMask[i/2+1]));
      fprintf(FileCmd, "route add default %s\n", inet_ntoa(*(struct in_addr *)&HIPaddrPC1[1]));
      fclose(FileCmd);

      fprintf(FileOut, "%s\n", CfgMsg[18]);
      fprintf(FileOut, "%s\n", CfgMsg[19]);
      fprintf(FileOut, "<br>\n");

      if ( Nat == 3 ) // socks
        {
        fprintf(FileOut, "<font color=\"#0000FF\">nameserver %s</font>\n",
                inet_ntoa(*(struct in_addr *)&HIPaddrPC1[1]));
        fprintf(FileOut, "<br>\n");
        fprintf(FileOut, CfgMsg[72], inet_ntoa(*(struct in_addr *)&HIPaddrPC1[1]));
        fprintf(FileOut, "\n");
        }
      else
        {
        fprintf(FileOut, "<font color=\"#0000FF\">nameserver 153.11.7.31</font>\n");
        fprintf(FileOut, "<br>\n");
        fprintf(FileOut, "%s\n", CfgMsg[20]);
        }
      }
    else
      if ( HOS[i] == 1 ) // Linux
        {
        fprintf(FileOut, " %s\n", CfgMsg[27]);
        fprintf(FileOut, " %s\n", CfgMsg[18]);
        if ( Nat == 3 ) // socks
          fprintf(FileOut, " %s\n", CfgMsg[73]);
        }
      else
        { // Windows
        fprintf(FileOut, "<br>%s\n", CfgMsg[28]);
        fprintf(FileOut, "%s\n", CfgMsg[29]);
        fprintf(FileOut, "%s\n", CfgMsg[30]);
        if ( Nat == 3 ) // socks
          fprintf(FileOut, "<p>%s\n", CfgMsg[73]);
        }

    fprintf(FileOut, "<br><br>\n%s\n<br>\n", CfgMsg[32]);
    if ( Nat == 1 )
      fprintf(FileOut, "%s\n<br>\n", CfgMsg[33]);
    else
      if ( Nat == 2 )
        {
        fprintf(FileOut, CfgMsg[34], inet_ntoa(*(struct in_addr *)&HIPaddrPC1[1]));
        fprintf(FileOut, "\n");
        }
      else
        {
        fprintf(FileOut, CfgMsg[35], inet_ntoa(*(struct in_addr *)&HIPaddrPC1[1]));
        fprintf(FileOut, "\n");
        }

    if ( HOS[i] == 2 )
      {
      fprintf(FileOut, "<br><br>\n%s\n<br>\n", CfgMsg[36]);
      if ( Nat == 1 )
        fprintf(FileOut, "%s\n<br>\n", CfgMsg[37]);
      else
        if ( Nat == 2 )
          {
          fprintf(FileOut, "%s<br>\n", CfgMsg[38]);
          fprintf(FileOut, CfgMsg[39], inet_ntoa(*(struct in_addr *)&HIPaddrPC1[1]), 3128);
          fprintf(FileOut, "\n");
          }
        else
          {
          fprintf(FileOut, "%s<br>\n", CfgMsg[38]);
          fprintf(FileOut, CfgMsg[39], inet_ntoa(*(struct in_addr *)&HIPaddrPC1[1]), 1080);
          fprintf(FileOut, "\n");
          }
      }
    }
  fprintf(FileOut, "</body>\n</html>\n");
  fclose(FileOut);
}
